<?php

function sql_concat($args, $db = "") {
 global $DB;

 $out = "";
 
 if (!$db) $db = $DB;
 
 if (!$args) return "";
 
 if ($db["type"] == "pgsql" || $db["type"] == "ora") {
 $out = implode(" || ",$args);
 } else {
 $out = "CONCAT(".implode(",",$args).")";
 }
 
 return $out;
}

function sql_substr($string,$pos,$len,$db = "") {
 global $DB;

 $out = "";

 if (!$db) $db = $DB;

 if ($db["type"] == "pgsql" || $db["type"] == "ora") {
 $out = "SUBSTR($string,$pos,$len)";
 } else {
 $out = "SUBSTRING($string,$pos,$len)";
 }

 return $out;
}

function sql_tab_alias($db = "") {
 global $DB;

 if (!$db) $db = $DB;

 if ($db["type"] == "ora") {
 $out = "";
 } else {
 $out = "AS";
 }

 return $out;
}

function sqlas($db = "") {
 return sql_tab_alias($db);
}

?>
