<?php


function checkpath($path,$perm = 0777,$absolute = false) {
 global $MKDIR_PATH, $DEBUG;
 if (strlen($path) == 0 ) return false;

 if (node_plattform() == "win32") {
 $dirs = explode("\\",realpath($path));
 $path = $dirs[0];
 for($i = 1;$i < count($dirs);$i++) {
 $path .= "/".$dirs[$i];
 if(!is_dir($path)) {
 mkdir($path,$mode);
 }
 }
 } else {
 $dirs = explode("/", $path);
 chdir('/');
 for ($i=1; $i < count($dirs); $i++) {
 if ($absolute && $i == 0) $dirs[$i] = "/".$dirs[$i];
 if (strlen($dirs[$i]) > 0) {
 if (!(@chdir($dirs[$i]))) {
 @mkdir($dirs[$i], $perm);
 if (!@chdir($dirs[$i])) return false;
 }
 }
 }
 }
 return true;
}




function format_filesize($size) {
 return $size." Kb";
}




function listfiles($path) {
 $delim = "/"; 

 if($dir=@opendir($path)) {
 $key = strrchr($path,$delim);
 $key = substr($key,1,strlen($key));

 while(($file=readdir($dir))!== false) {
 if(@is_dir($path.$delim.$file) AND $file!= "." AND $file!= "..") {
 $subarray = listfiles($path.$delim.$file);
 if (!is_array($array)) {
 $array = array();
 }
 if (is_array($subarray)) {
 $array = array_merge($array, $subarray);
 }
 } elseif($file!= "." AND $file!= "..") {
 $array[] = $path.$delim.$file;
 }
 }
 closedir($dir);
 }
 return $array;
}


function listdirectories($path) {
 $delim = "/"; 

 if($dir=@opendir($path)) {
 $key = strrchr($path,$delim);
 $key = substr($key,1,strlen($key));

 while(($file=readdir($dir))!== false) {
 if(@is_dir($path.$delim.$file) AND $file!= "." AND $file!= "..") {
 $array[] = $path.$delim.$file;
 $subarray = listdirectories($path.$delim.$file);
 if (is_array($subarray)) {
 $array = array_merge($array, $subarray);
 }
 }
 }
 closedir($dir);
 }
 return $array;
}

function getfiletype($filename) {
 $path_parts = pathinfo($filename);
 return strtoupper($path_parts["extension"]);
}

function getfilescheme($filename) {
 $url = parse_url($filename);
 return strtoupper($url["scheme"]);
}

function getfilename($filename) {
 $path_parts = pathinfo($filename);
 return $path_parts["basename"];
}


function getdbfiletype($filename) {
 global $CN_MIME_TYPES;
 $filetype = strtoupper(getfiletype($filename));
 $type = $CN_MIME_TYPES[$filetype];
 if (is_null($type)) {
 $type = "application/octet-stream";
 }
 return $type;
}


function resolvepath($path) {

 
 $parts = split('/',$path);

 $path = "";
 for ($i = sizeof($parts) -1; $i > 0; $i--) {

 
 
 $dots = 0;
 while ($parts[$i] == ".." || $parts[$i] == ".") {
 if ($parts[$i] == "..") {
 $dots++;
 }

 $i--;
 }

 
 if ($dots) $i-=($dots);
 if ($i > 0) {
 $path = "/".$parts[$i].$path;
 }
 }

 return $path;
}


?>
