<?php

class FileComponent extends FormComponent {

 var $file;
 var $resize;
 var $customResize;
 var $usetmpfile;

 



 function FileComponent($label = NULL, $optional = true, $resizeable = false, $usetmpfile = false) {
 parent::FormComponent($label, true, $optional);
 $this->resize = $resizeable;
 $this->customResize = false;
 $this->file = new FileObject();
 $this->usetmpfile = $usetmpfile;
 }

 function setResizeable($val) {
 $this->resize = ($val);
 }

 function setCustomResize($val) {
 $this->customResize = $val;
 }

 function getResizeFields() {
 global $CN_IMAGEUPLOAD_SIZE;
 if (is_array($this->customResize)) {
 return $this->customResize;
 } else if (is_array($CN_IMAGEUPLOAD_SIZE)) {
 return $CN_IMAGEUPLOAD_SIZE;
 } else {
 return array();
 }
 }

 function getOriginalType() {
 return $this->d_values["origType"];
 }
 
 function getOriginalName() {
 return $this->d_values["origName"];
 }

 function isUploaded() {
 return ($this->d_values["origName"]);
 }
 
 function getSerializeKey() {
 $rs["parent"] = parent::getSerializeKey();
 $rs["file"] = node_serialize($this->file);
 $rs["resize"] = $this->resize;
 $rs["customResize"] = serialize($this->customResize);
 $rs["usetmpfile"] = $this->usetmpfile;
 return $rs;
 }

 function initFromSerializeKey($key) {
 parent::initFromSerializeKey($key["parent"]);
 $this->file = node_unserialize($key["file"]);
 $this->resize = $key["resize"];
 $this->customResize = unserialize($key["customResize"]);
 $this->usetmpfile = $key["usetmpfile"];
 }

 function getFields() {
 return array_merge(parent::getFields(), array("fname"=>"Variable name of upload field", "f_resize"=>"new Size", 
 "origType"=>"original File Type", "origName"=>"original File Name"));
 }

 function toString() {
 $obj = $this->getResultObject();
 return $obj->toString();
 }

 function &getResultObject() {
 if ($this->resize) {
 
 
 }
 return $this->file;
 }

 function onLoadFinished() {
 $fname = $this->d_values["fname"];
 $this->d_values["fname"] = "";

 $files = $_FILES;
 if (isset($files[$fname])) {
 $file = new FileObject($files[$fname]["tmp_name"]);
 $this->d_values["origName"] = $files[$fname]["name"];
 $this->d_values["origType"] = $files[$fname]["type"];
 
 
 
 
 
 
 
 if( $this->usetmpfile ) {
 $this->file = $file;
 } else {
 $this->file->setContent($file->readContent());
 }
 
 if (false && $this->file->getFilename()) {
 $err = $this->file->store();
 if (!$err) {
 $this->file->resetContent();
 } else {
 $this->addError($err);
 }
 }

 
 }

 if (!$this->isOptional() && $this->file->isEmpty()) {
 $this->addError(new NodeException(i18n("You must upload a non-empty file.")));
 }
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $formName = $form->getFormName();
 $html = "<input type=hidden name=\"${fieldPrefix}fname\" value=\"${fieldPrefix}f\">";
 $html .= "<input type=file name=\"${fieldPrefix}f\" class=\"solid\" style=\"$strStyle\">";
 
 if ($this->resize) {
 
 
 
 }
 
 return $this->mergeResult( $this->getErrorDiv($form, $fieldPrefix), $this->mergeResult( parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html ) );
 }

 function setFileObject(&$file) {
 $this->file =& $file;
 }

}

?>
