<?php

GUIFactory::setMainGUI("main");

if (!$cmd) $cmd = $f_cmd;

$hi = Array();

if ($cmd == "save") {
 $f = $HI["text"];
 $f["label"] = i18n("name");
 $f["var"] = "name";
 $hi[] = $f;

 $title = i18n("cn_statistic");
}
if ($cmd == "load") {
 $f = $HI["date"];
 $f["label"] = i18n("date");
 $f["var"] = "date";
 $hi[] = $f;

 $f = $HI["hidden"];
 $f["var"] = "config_id";
 $hi[] = $f;
}

if ($cmd == "period") {
 $f = $HI["date"];
 $f["var"] = "start";
 $f["label"] = i18n("start");
 $hi[] = $f;

 $f = $HI["date"];
 $f["var"] = "end";
 $f["label"] = i18n("end");
 $hi[] = $f;

 $f = $HI["hidden"];
 $f["var"] = "config_id";
 $hi[] = $f;

 $title = i18n("periode");
}

$f = $HI["hidden"];
$f["var"] = "cmd";
$hi[] = $f;

$hi[] = $HI["ok"];

if (!$faction && $cmd == "load") {
 $date = $TIME;
}

$f = new htmlform($hi,"stat_period");

if (!$faction) {

 if ($STAT_PERIOD["start"] && $STAT_PERIOD["end"]) {
 $start = $STAT_PERIOD["start"];
 $end = $STAT_PERIOD["end"];
 } else {
 $start = mktime(0,0,0,date("m"),1,date("Y"));
 $end = $TIME;
 $STAT_PERIOD["start"] = $start;
 $STAT_PERIOD["end"] = $end;
 }
 $f->load_script_vars();
}

if ($faction == "ok") {
 if ($cmd == "save") {
 $sql = "INSERT INTO cnstatconfig (name, statkeys, active) VALUES (\"".sqlslashes($name)."\", \"".sqlslashes(serialize($STATS_CSTATS))."\",1)";
 query($sql);
 $f->clear();
 $REDO = 15104;
 }
 if ($cmd == "load") {

 
 $sql = "SELECT MIN(timestamp) AS min FROM cnstatval WHERE cnstatconfig_id = ".sqlf_tl_num($config_id)." AND timestamp >= ".sqlf_tl_num($date);
 $rs = query($sql);
 $min = ($rs["num"])?$rs["arr"][0]["min"]:0;

 $sql = "SELECT MAX(timestamp) AS max FROM cnstatval WHERE cnstatconfig_id = ".sqlf_tl_num($config_id)." AND timestamp <= ".sqlf_tl_num($date);
 $rs = query($sql);
 $max = ($rs["num"])?$rs["arr"][0]["max"]:0;

 $time = (abs($date - $max) > abs($min - $date) && $min) ? $min : $max;
 
 $sql = "SELECT DISTINCT field FROM cnstatval WHERE timestamp = ".sqlf_tl_num($time)." AND cnstatconfig_id = ".sqlf_tl_num($config_id);
 $rs = query($sql);

 $rows = array();
 while (list($key,$val) = each($rs["arr"])) {
 $rows["stats"][$val["field"]] = true;
 }

 $sql = "SELECT statkeys FROM cnstatconfig WHERE id = ".sqlf_tl_num($config_id);
 $rs = query($sql);
 
 $cols = unserialize($rs["arr"][0]["statkeys"]);

 if (!is_array($cols)) $cols = array();
 
 reset($cols);
 while (list($key,$val) = each($cols)) {

 if ($val["type"] == $T_USER && $val["id"] == 1) {
 unset($cols[$key]);
 continue;
 }
 
 $sql = "SELECT field, textvalue, intvalue FROM cnstatval WHERE cnstatconfig_id = ".sqlf_tl_num($config_id)." AND timestamp = ".sqlf_tl_num($time)." AND col = ".sqlf_tl_num($key);
 $rs = query($sql);

 $cols[$key]["stats"] = array();
 while (list($k,$v) = each($rs["arr"])) {
 $cols[$key]["stats"][$v["field"]] = ($v["textvalue"])?$v["textvalue"]:(int) $v["intvalue"];
 }
 
 $cols[$key] = get_objectname($cols[$key]);
 }

 mysession_var_reg("STATS_ROWS");
 mysession_var_reg("STATS_CSTATS");
 $STATS_ROWS = $rows;
 $STATS_CSTATS = $cols;
 
 $REDO = 15102;
 $cmd = "html";
 }

 if ($cmd == "period") {
 mysession_var_reg("STAT_PERIOD");
 $STAT_PERIOD["start"] = mktime(0,0,0,date("m",$start),date("d",$start), date("Y",$start));
 $STAT_PERIOD["end"] = mktime(0,0,0,date("m",$end),date("d",$end)+1, date("Y",$end)) - 1;

 $sql = "SELECT statkeys FROM cnstatconfig WHERE id = ".sqlf_tl_num($config_id);
 $rs = query($sql);

 $cols = unserialize($rs["arr"][0]["statkeys"]);

 if (!is_array($cols)) $cols = array();

 $period = $STAT_PERIOD;
 
 reset($cols);
 while(list($key,$val) = each($cols)) {

 if ($val["type"] == $T_USER && $val["id"] == 1) {
 unset($cols[$key]);
 continue;
 }

 $logstat = get_logstats($val["keys"],$period);
 $cols[$key]["stats"] = $logstat;
 
 $today = get_actualstats($val["keys"]);
 $cols[$key]["today"] = $today;

 
 $cols[$key] = get_objectname($cols[$key]);

 
 reset($logstat);
 while (list($k,$v) = each($logstat)) {
 $rows["stats"][$k] = true;
 }
 reset($today);
 while (list($k,$v) = each($today)) {
 $rows["today"][$k] = true;
 }
 }

 mysession_var_reg("STATS_ROWS");
 mysession_var_reg("STATS_CSTATS");
 $STATS_ROWS = $rows;
 $STATS_CSTATS = $cols;

 $REDO = 15102;
 $cmd = "html";
 unset($nid);
 }
}

?>
