<?php
node_include("contentgroup");

function ml_import_seek($template_source, $page_source, $start, $dir = "left",$tag = "") {
 global $DEBUG, $match_before, $match_after;
 
 
 if (!$match_before) {
 $match_before = 2;
 }
 
 if (!$match_after) {
 $match_after = 2;
 }
 
 if ($dir == "left") {
 $step = min(20, $start + 1);
 } else {
 $step = 20;
 }
 $search = true;
 $way = 0;
 $template_source = strtoupper($template_source);
 $page_source = strtoupper($page_source);
 $arr_search_replace = array(
 "\n" => "\\n",
 "\r" => "\\r",
 "\t" => "\\t",
 " " => "."
 ); 
 
 while ($search) {
 
 if ($dir == "left") {
 $startstep = ($start-$step < 0) ? 0 : $start - $step + 1;
 $tmp = substr($template_source,$startstep,$step);
 } else {
 $tmp = substr($template_source,$start,$step);
 }
 
 $count = substr_count($page_source,$tmp);
 
 if ($DEBUG["import"]) {
 echo "searching for <b>".htmlspecialchars(str_replace(array_keys($arr_search_replace),array_values($arr_search_replace),$tmp))."</b> in direction $dir. found $count matches with step= $step way= $way\n";
 echo "\n\n\n<font color=blue>$count</font><hr>\n\n\n";
 }
 
 
 if ($count > 1) {
 if ($way == -1) {
 $search = false;
 }
 $step++;
 $way = 1;
 } elseif ($count < 1) { 
 if ($way == 1) {
 $search = false;
 }
 
 if ($dir == 'left' && $step == $match_before) {
 $search = false;
 }
 if ($dir == 'right' && $step == $match_after) {
 $search = false;
 }
 
 $step--;
 $way = -1;
 } else {
 $search = false;
 
 if ($dir == "left") {
 $pos = strpos($page_source, $tmp) + $step;
 } else {
 $pos = strpos($page_source, $tmp);
 }
 }
 
 





 if ($dir == "left" && $start - $step == -20) {
 $search = false;
 } else if ($start + $step > strlen($page_source) + 20) {
 $search = false;
 } 
 }
 
 if ($DEBUG["import"]) {
 echo "<font color=green>$pos | start: $start, step: $step at len:".strlen($page_source)." tpl: ".strlen($template_source)."</font><br>";
 }
 
 return $pos;
}

function ml_import($source, $stemplate_id, &$logger, $dtemplate_id = -9999, $url="", $foldername = -9999, $pagename = -9999, $keepfilename = 0, $keepfolders = 0, $contentgroup_id = 0, $diff = false) {
 global $SID, $TMPPATH, $TAG_PREFIX, $FOLDER_ID, $JS, $ERROR, $CN_IMPORT_PAGES, $CN_IMPORT_FOLDERS, $CN_IMPORT_FILES, $constr_tags, $part_type_id, $DEBUG;
 global $FEATURE;

 
 if ($dtemplate_id == "-9999") $dtemplate_id = $stemplate_id;
 if ($pagename == "-9999") {
 unset($pagename);
 } else {
 $PAGENAME_FROM_TAG = $pagename;
 }
 if ($foldername == "-9999") unset ($foldername);
 $template = get_templateinfo($stemplate_id);
 $template_source = trim(cleannl($template["ml"]));
 $source = trim(cleannl($source));
 $md5 = md5($source);

 $tag_prefix_length = strlen($TAG_PREFIX);
 $offset = 0;
 $lastpos = 0;
 if ($DEBUG["import"]) echo "<pre>".htmlspecialchars($template_source)."</pre><hr>\n\n";
 if ($DEBUG["import"]) echo "<pre>".htmlspecialchars($source)."</pre><hr>\n\n";
 while (!is_false($pos1 = strpos($template_source,"<$TAG_PREFIX ",$offset))) {
 $pos2 = strpos($template_source,">",$pos1);
 
 if (!$pos2) $pos2 = $pos1 + $tag_prefix_length + 1;

 $fulltag = substr($template_source,$pos1, $pos2 - $pos1 + 1);
 $tagname = substr($fulltag, $tag_prefix_length + 2, strlen($fulltag) - ($tag_prefix_length + 3));

 if ($offset == 0) $tmp = 0;
 else $tmp = $offset + 1;
 
 if ($DEBUG["import"]) echo "pos1: $pos1, pos2: $pos2<br/>";
 $end = ml_import_seek($template_source,$source,$pos2+1,"right",$tagname);
 $start = ml_import_seek($template_source,$source,$pos1-1,"left",$tagname);

 if ($DEBUG["import"]) echo '<pre>'.htmlspecialchars(substr($source, 0, $start)).'</pre><font color=red>'.htmlspecialchars(substr($source, $start, $end-$start)).'</font><pre>'. htmlspecialchars(substr($source,$end)).'</pre>';
 
 if ($start && $end) {
 $tags[$tagname] = substr($source,$start,$end-$start);
 }

 $offset = $pos2;
 }

 
 
 if ($keepfolders) {
 
 $_url = $url;
 while (!$folder_id) {
 $folder_id = $CN_IMPORT_FOLDERS[strtolower(dirname($_url))]["id"];
 $_url = dirname($_url);

 
 if ($_url == "/") $folder_id = $FOLDER_ID;
 }
 } else {
 $folder_id = $FOLDER_ID;
 }

 
 $name = $tags[$pagename];
 $path_parts = pathinfo($url);
 $urlname = substr($path_parts["basename"],0, (strlen($path_parts["basename"]) - strlen($path_parts["extension"]) - 1));
 if (!$name) {
 $name = $urlname; 
 }
 
 $pagename = $name;
 $filename = $urlname.".".$path_parts["extension"];
 $page_id = 0;

 
 
 global $import_pagename_from_filename;
 if ($import_pagename_from_filename) {
 $parts = split_import_filename($filename);
 if ( ! is_null($parts) ) {
 $pagename = $parts["page_name"];
 $filename = $parts["file_name"];
 } else {
 $logger->addText("Warning: filename $filename doesn't conform"
 . " to the import_pagename_from_filename option."
 . " Falling back to default naming convention.");
 }
 }

 
 if (strlen($filename) > 64) {
 $logger->addText("Error while importing $filename: filename too long (max allowed: 64 characters)", true);
 return 0;
 }

 $folderinfo = get_folderinfo($folder_id);

 
 
 global $import_autodetect_contentgroup;
 if ($import_autodetect_contentgroup) {
 $autodetected_cg_id = contentgroup_for_filename($filename, $folderinfo["node_id"]);
 $valid_cg = ! is_null($autodetected_cg_id);
 if ($valid_cg) {
 $contentgroup_id = $autodetected_cg_id;
 }
 }

 
 if ( ! $valid_cg && $FEATURE["contentgroup3"] && $contentgroup_id) {
 $cg = get_contentgroups($folderinfo["node_id"]);
 while (list($key,$val) = each($cg)) {
 if ($key == $contentgroup_id) {
 $valid_cg = true;
 break;
 }
 }
 }

 if ($diff) {
 $order_by = "";
 $conflict_cond = "name = '" . sqlslashes($pagename) . "'";

 
 
 
 global $import_autodetect_contentset;
 if ($import_autodetect_contentset && $valid_cg) {
 $conflict_cond = "(" . $conflict_cond . " AND contentgroup_id = " . sql_num($contentgroup_id) . ")";
 }

 global $import_diff_only_filename;
 if ($import_diff_only_filename || $FEATURE["ml_import_diff_by_filename"]) {
 $conflict_filename_cond = "filename = '".sqlslashes($filename)."'";
 if ($import_diff_only_filename) {
 
 
 $conflict_cond = $conflict_filename_cond;
 } else {
 
 
 $order_by = "ORDER BY " . $conflict_filename_cond . " DESC";
 $conflict_cond .= " OR " . $conflict_filename_cond;
 }
 }

 $rs = query("SELECT id, description, content_id FROM page WHERE ($conflict_cond) AND folder_id = ".sqlf_tl_num($folder_id)." $order_by");
 if ($rs["num"] > 0) {
 $origMd5 = $rs["arr"][0]["description"];
 if ($origMd5 == $md5) {
 return -$rs["arr"][0]["id"];
 } else {
 $page_id = $rs["arr"][0]["id"];
 $content_id = $rs["arr"][0]["content_id"];
 }
 }
 }
 else {
 $conflicts = 0;
 do {
 if ($conflicts) {
 $pagename = "$name-$conflicts";
 $filename = "$urlname-$conflicts".".".$path_parts["extension"];
 }
 $conflict_cond = "name = '" . sqlslashes($pagename) . "'";
 if ($FEATURE['ml_import_compare_filename']) {
 $conflict_cond .= " OR filename = '" . sqlslashes($filename) . "'";
 }
 $rs = query("SELECT id FROM page WHERE ($conflict_cond) AND folder_id = ".sqlf_tl_num($folder_id));
 $conflicts++;
 } while ($rs["num"] > 0);
 }

 
 if ($keepfilename) {
 $fn = $filename;
 } else {
 $fn = "";
 }

 if (!$page_id) {

 
 if ($valid_cg) {

 
 global $import_autodetect_contentset;
 if ($import_autodetect_contentset) {
 $contentset_id = contentset_for_filename($filename, $folder_id, $folderinfo["node_id"]);
 
 if ( ! is_null($contentset_id)
 && contentgroup_exists_in_contentset($contentgroup_id, $contentset_id) )
 {
 $logger->addText("Unable to add new page '$filename' with contentgroup"
 . " $contentgroup_id to contentset $contentset_id."
 . " A page with that contentgroup already exists under a"
 . " different page or file-name (or both)");
 return 0;
 }
 }

 
 if ( ! isset($contentset_id) ) {
 $contentset_id = cmd_page_createcs();
 }

 
 
 $page_id = cmd_page_create($pagename,"",5,$fn,$dtemplate_id,$folder_id, $contentgroup_id, $contentset_id, true);
 }
 else {
 
 
 $page_id = cmd_page_create($pagename,"",5,$fn,$dtemplate_id,$folder_id, 0, 0, true);
 }

 } else {
 
 if ($content_id) {
 global $import_keep_destination_tags;
 if ($import_keep_destination_tags) {
 
 
 
 
 
 delete_public_template_tags($content_id, $stemplate_id);
 delete_tags_not_originating_from_template($content_id, $dtemplate_id);
 } else {
 
 tags_del($content_id,"content");
 }
 tag_copy($dtemplate_id,"template",$content_id,"content");
 }

 
 
 cmd_page_update($page_id, $pagename, "", 5, $fn, $dtemplate_id, 0, $contentgroup_id );
 }
 
 if ($page_id) {
 
 lock($page_id, "page");

 
 
 $sql = "SELECT contenttag.id as tag_id
FROM contenttag
LEFT JOIN page ON (contenttag.content_id = page.content_id)
WHERE page.id = ".sqlf_tl_num($page_id);
 $rs = query($sql,true,0,0);
 if ($rs["num"]) {
 while (list($row_id, $row) = each($rs["arr"])) {
 if ($row["tag_id"]) {
 $rs1 = query("SELECT part.*, contenttag.name"
 . " FROM part JOIN contenttag"
 . "   ON contenttag.construct_id = part.construct_id"
 . " WHERE part.keyword = 'cn_value'"
 . "   AND contenttag.id = " . sql_num($row["tag_id"]));
 if (0 == $rs1["num"]) {
 
 
 
 
 
 
 
 
 if ($FEATURE["cn_page_import_fill_editable_part"]) {
 $sql_and = "part.editable <> 0";
 } else {
 $sql_and = "part.hidden = 0";
 }
 $sql = "SELECT part.*, contenttag.name"
 . " FROM part"
 . " JOIN contenttag ON contenttag.construct_id = part.construct_id"
 . " WHERE $sql_and" 
 . " AND contenttag.id = " . sql_num($row["tag_id"]);
 $rs1 = query($sql,true,0,0);
 }
 if ($rs1["num"]) {
 $parts[$rs1["arr"][0]["name"]] = Array(
 "pid"=>$rs1["arr"][0]["id"],
 "type_id"=>$rs1["arr"][0]["type_id"],
 "construct_id"=>$rs1["arr"][0]["construct_id"],
 "tag_id"=>$row["tag_id"],
 "_tagname"=>$rs1["arr"][0]["name"]
 );
 }
 }
 }
 }

 if (is_array($tags)) {
 reset($tags);
 while (list($tagname, $val) = each($tags)) {
 if (is_Array($parts[$tagname])) {
 $tmp = "p".$parts[$tagname]["pid"]."_a"; 
 global $$tmp;
 
 


 

 
 $_tmp = ml_parse($val, $page_id, $url);
 if (is_global_validation_error()) {
 $logger->addText(global_validation_error_message());
 return 0;
 }

 $_tmp = trim(cleannl($_tmp));
 

 $part_id = $parts[$tagname]["pid"];

 if ($parts[$tagname]["type_id"] == 6) {
 
 $tmp = "p".$part_id."_a";
 $img_path = reltofull($url, $val);
 $val = 0;

 if ($CN_IMPORT_FILES[strtolower($img_path)]["id"] && $CN_IMPORT_FILES[strtolower($img_path)]["type"] == "image") {
 
 $image_id = $CN_IMPORT_FILES[strtolower($img_path)]["id"];
 } else {
 
 
 $image_id = cmd_saveimportimage($img_path, $page_id);
 }

 $val = $image_id;
 unset($image_id);
 } elseif ($parts[$tagname]["type_id"] == 8) {
 $filelink = ml_getfilepath($val, dirname($url));
 
 $cn_import_file_id = $CN_IMPORT_FILES[strtolower($filelink)]["id"];

 if (is_int($cn_import_file_id)) {
 
 $tmp = "p".$part_id."_a";
 $tmp1 = "p".$part_id."_c";
 $val = $cn_import_file_id;
 $val1 = "a";
 } else {
 
 $tmp = "p".$part_id."_b";
 $tmp1 = "p".$part_id."_c";
 $val1 = "b";

 
 $part_todo = array();
 $part_todo["part_id"] = $part_id;
 $part_todo["type_id"] = $part_type_id[$part_id];
 $part_todo["cid"] = $constr_tags[$tagname];
 $part_todo["editable"] = 1;
 $part_todo["type"] = "content";
 $part_todo["tag_id"] = $parts[$tagname]["tag_id"];

 if ($filelink) $CN_IMPORT_PAGES[$filelink]["parts"][] = $part_todo;
 }
 } else {
 $tmp = "p".$part_id."_a";
 $val = $_tmp;
 }

 $$tmp = $val;
 $$tmp1 = $val1;

 global $tmp, $tmp1;
 part_update($parts[$tagname]["pid"],$parts[$tagname]["type_id"],$parts[$tagname]["construct_id"],1,"content",$parts[$tagname]["tag_id"]);
 if (is_global_validation_error()) {
 $logger->addText(global_validation_error_message());
 return 0;
 }

 if ($DEBUG["import"]) echo "<h1>".$parts[$tagname]["tag_id"]."</h1><br>";
 if ($DEBUG["import"]) echo "[<font color=orange>$val</font>]";

 
 if ($val !== false && $val !== "") {
 $sql = "UPDATE contenttag SET enabled = 1 WHERE id = ".sqlf_tl_num($parts[$tagname]["tag_id"]);
 query($sql);
 }
 }
 }
 }

 
 cmd_page_update($page_id, $pagename, $md5, 5, $fn, $dtemplate_id, 0, $contentgroup_id );

 
 unlock($page_id, "page");

 
 if ($content_id) {
 global $T_PAGECONTENT;
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_PAGECONTENT, $content_id);
 }

 
 return $page_id;
 } else {
 
 return 0;
 }
}


















function contentset_for_filename($filename, $folder_id, $node_id) {
 $all_filenames = filename_in_contentgroups($filename, $node_id);
 
 
 if ( ! $all_filenames ) {
 return null;
 }
 
 
 
 $rs = query("SELECT contentset_id FROM page"
 . " WHERE folder_id = " . sql_num($folder_id)
 . "   AND filename IN (" . sql_str_list($all_filenames) . ")"
 . " LIMIT 1");
 if ( ! $rs['arr'] ) {
 return null;
 }
 return $rs['arr'][0]['contentset_id'];
}










function contentgroup_for_filename($filename, $node_id) {
 list($prefix, $lang_code, $suffix) = split_filename_along_language_code($filename);
 if (is_null($prefix)) {
 return null;
 }
 $cg = get_contentgroups($node_id);
 
 $lang_code = strtolower($lang_code);
 foreach ($cg as $id => $props) {
 if ($lang_code == strtolower($props["code"])) {
 return $id;
 }
 }
 return null;
}


















function filename_in_contentgroups($filename, $node_id) {
 list($prefix, $lang_code, $suffix) = split_filename_along_language_code($filename);
 if (is_null($prefix)) {
 return null;
 }
 $cg = get_contentgroups($node_id);
 $lang_code = strtolower($lang_code);
 $lang_code_valid = false;
 $filenames = array();
 foreach ($cg as $id => $props) {
 if ($lang_code == strtolower($props["code"])) {
 $lang_code_valid = true;
 }
 $filenames[] = $prefix . $props["code"] . $suffix;
 }
 if ( ! $lang_code_valid ) {
 return null;
 }
 return $filenames;
}













function split_filename_along_language_code($filename) {
 if ( ! preg_match('/^([^\.]*\.)([^\.]+)(.*)$/', $filename, $matches) ) {
 return null;
 }
 return array($matches[1], $matches[2], $matches[3]);
}





function contentgroup_exists_in_contentset($contentgroup_id, $contentset_id) {
 $rs = query("SELECT id FROM page"
 . " WHERE contentgroup_id = " . sql_num($contentgroup_id)
 . "   AND contentset_id = " . sql_num($contentset_id));
 return (bool)$rs["num"];
}

















function split_i18n_filename($filename) {
 if ( ! preg_match('/^(?:(.*?)\.)?([^\.]+)\.([^\.]+)\.([^\.]+)$/', $filename, $matches) ) {
 return null;
 }
 return array('name_i18n' => $matches[1],
 'name' => $matches[2],
 'code' => $matches[3],
 'extension' => $matches[4]);
}
















function split_import_filename($filename) {
 $parts = split_i18n_filename($filename);
 if (is_null($parts)) {
 return null;
 }
 if ($parts["name_i18n"] !== '') {
 $pagename = $parts["name_i18n"];
 } elseif ($parts["name"] !== '') {
 $pagename = $parts["name"];
 } else {
 return null;
 }

 $filename = $parts["name"] . "." . $parts["code"] . "." . $parts["extension"];
 return array("page_name" => $pagename,
 "file_name" => $filename);
}


