<?php
GUIFactory::setMainGUI( "main" );
node_class( "htmlform3" );
node_class( "tabcomponent" );
node_class( "datecomponent" );
node_class( "propertytreecomponent" );
node_class( "extendablecomponent" );
node_class( "dialoghiselector" );
node_class( "detailcomponent" );
node_class( "selectcomponent" );
node_class( "cnpageobject" );
node_class( "xnlfunctioncomponent" );
node_class( "checkboxcomponent" );
node_class( "sqldatasource" );
node_class( "itemlistcomponent" );
node_class( "itemlist3" );
node_class( "chartcomponent" );
node_class( "chartdata" );
node_class( "componentchooser" );

node_class( "minibrowserhiselector" );
node_class( "pageselector" );
node_class( "cnfolderobject" );
node_class( "labelcomponent" );

$DEBUG["stuff"] = $DEBUG["warn"] = TRUE;

function action1( &$form, $param )
{
 $tabC =& $form->getComponent( "tab" );
 $tC = & $tabC->getComponent( "t" ); 
 echo "action, text: ".$tC->getText()."<br />";
}

function action2( &$form, $param )
{
 global $JS_ONLOAD;
 $JS_ONLOAD .= "\nalert('Selber Hallo...');";
}


function doitnow( &$form, $param )
{
 if ( !$form->componentExists("text2") )
 {
 $form->addComponent( "text2", new TextComponent(i18n("New Text:"), TRUE,"",REG_TEXT ) );
 if ( !$form->buttonExists( "remove" ) )
 $form->addButton( "remove", new Button( i18n( "Remove" ), FALSE ), new SimpleFormAction( "doitnow" ) );
 }
 else
 {
 $c =& $form->getComponent( "text2" );
 $c->setHidden( !$c->isHidden() );
 $btn = &$form->getButton( "remove" );
 $btn->setLabel( $c->isHidden()?"Add":"Remove" );
 $btn2 = &$form->getButton( "hallo" );
 $btn2->setEnabled( $c->isHidden() );
 }
}

function actionSelector( &$form, $param )
{
 echo "Selection changed<br />";
}

function hideChartTabs( &$form, $param ) {
 
 $list =& $form->resolveComponent("tab.c");
 $check =& $list->getComponent("s");
 $tab =& $list->getComponent("c");
 
 if ($check->isChecked()) {
 $tab->setHidden(true);
 $list->setComponent("r", new ChartComponent( ChartRendererFactory::getInstanceOf( $tab->getActiveTab(), $tab->getChartData() ) ), "c" );
 } else {
 $tab->setHidden(false);
 $list->unsetComponent("r");
 }
}

function onPageSelected( &$form, $param )
{
}

$form = new HtmlForm3( "demo" );
if ( $form->isNew() )
{
 
 $select = "id, firstname, lastname, login, cdate";
 $from = "systemuser";
 $where = "active = 1";
 
 $ds = new SQLDatasource( "people", $select, $from, $where );
 
 
 $ds->addColumn( "lnkfirstname", i18n("Firstname"), false, "firstname", "firstname");
 $ds->addColumn( "lastname", i18n("Lastname"), true, true, true );
 $ds->addSearchableColumn( "login" );
 
 $ds->makeLink("lnkfirstname","firstname", "do=1001", "list", "mylogin", "login");
 $ds->setAss("\$firstname \$lastname");
 
 $itemlist = new ItemList3( "test", $ds );


 $list2 = new ListComponent();
 $list2->setComponent( "l", new LabelComponent( "Text:", "<b>Read me</b>", true ) );
 $list2->setComponent( "t", new TextComponent( "Text:", TRUE ) );
 $list2->setComponent( "t2", new DateComponent("Datum:") );


 $list3 = new ListComponent();
 $list3->setComponent( "t", new TextComponent( NULL, TRUE ) );
 $list3->setComponent( "d", new DateComponent() );

 
 $list4 = new ListComponent();
 $list4->setComponent( "sel1", new DialogTextHiSelector( new PropertyTreeComponent( new CNFolderObject(10) ), "Select Property:" ) );
 $list4->setComponent( "sel2", new ExtendableComponent( new TextComponent("Select Property:"), new PropertyTreeComponent( new CNFolderObject(10) ) ) );
 $list4->setComponent( "sel3", new FrameHiSelector( new PropertyTreeComponent( new CNFolderObject(10) ), new TextComponent("Select Property:") ) );
 $list4->setComponent( "sel4", new DialogTextHiSelector( new FrameHiSelector( new PropertyTreeComponent( new CNFolderObject(10) ), 
 new TextComponent("Select Property:") ), "Select Property:" ) );
 
 
 $list4->setComponent( "sel6", new DialogTextHiSelector( new XNLFunctionComponent( ), "Select Function:") ) ;
 
 
 $list4->setComponent( "sel7", new MinibrowserHiSelector( new PageSelector(), i18n("Select Minitree:") ) );
 
 $chartData = array();
 $chartData[0][] = array("name" => "Name 1", "value" => 2, "description" => "Desc 1");
 $chartData[0][] = array("name" => "Name 2", "value" => 1, "description" => "Desc 2");
 $chartData[0][] = array("name" => "Name 3", "value" => 3, "description" => "Desc 3");
 $chartData[0][] = array("name" => "Name 4", "value" => 2.5, "description" => "Desc 4");
 $chartParam = array("xTitle" => "Bars", "yTitle" => "Values");
 
 $checkbox = new CheckBoxComponent( i18n( "Hide Tabs" ) );
 $checkbox->setOnChangeAction( new SimpleFormAction( "hideChartTabs" ) );
 
 $list5 = new ListComponent();
 $list5->setComponent("c", new ChartsComponent( new ChartData( $chartData, $chartParam ) ) );
 $list5->setComponent("s", $checkbox );
 
 $select = new SelectComponent( "label", array( "test"=>"Auswahl", "test2"=>"mehr Auswahl" ), "test2" );
 $select->setOnChangeAction ( new SimpleFormAction( "actionSelector" ) );
 $select->enableMultipleSelect( 5 );

 $radio = new RadioListComponent( "hallo", array("test"=>"Auswahl", "test2"=>"noch mehr Auswahl" ) );
 

 $listOptions = new ListComponent();
 $listOptions->setComponent( "sel", $select );
 $listOptions->setComponent( "radio", $radio );
 
 $chooser = new ComponentChooser("Chose something");
 $chooser->setComponent( "t1", new TextComponent("Intern", TRUE) );
 $chooser->setComponent( "t2", new TextComponent("Extern", true) );

 $text = new TextComponent( "Text:", TRUE, "", REG_NOTEMPTY );
 $text->setHelp( i18n("Some help text." ) );
 
 $list1 = new TabComponent();
 $list1->setTab( "t", "Text", $text, $ICO_EDIT );
 $list1->setTab( "d", "Date", new ExtendableComponent( new DateComponent(NULL, $TIME, DCP_DATETIME), new CalendarComponent() ), $ICO_TIMECLOCK );
 $list1->setTab( "l", "List", $list2, "$STAG&do=11&module=content&img=constr/olist.gif" );
 $list1->setTab( "e", "Tree", new PropertyTreeComponent( new CNPageObject(159) ), $ICO_TREEMENU );
 $list1->setTab( "s", "Selector", $list4, $ICO_FOLDER );
 $list1->setTab( "ch", "Chooser", $chooser );
 $list1->setTab( "li", "Itemlist", new ItemListComponent( NULL, $itemlist ), $ICO_LIST );
 $list1->setTab( "se", "Options", $listOptions );
 $list1->setTab( "ext", "Extendable", new ExtendableComponent( new TextComponent(""), 
 new PropertyTreeComponent( new CNPageObject(10) ) ) );
 $list1->setTab( "c", "Chart", $list5 );
 $list1->setActiveTab( "ch" );

 $form->setHeader(i18n("small Demo"), $ICO_FOLDER);

 $form->addComponent( "tab", $list1 );
 $form->addComponent( "det", new DetailComponent( "hidden", "shown", 
 new TextComponent( "hallo", TRUE, "", REG_DATE ) ) );

 
 $form->addButton( "ok", new Button( i18n( "OK" ) ), new SimpleFormAction( "action1" ), TRUE );
 
 
 $form->addButton( "hallo", new Button( i18n( "Hallo" ), FALSE ), new SimpleFormAction( "action2" ) );
 
 $form->addButton( "disabled", new Button( "Disabled", TRUE, FALSE ), new SimpleFormAction( "action2" ) );
 $call = $form->getJsActionCall( new SimpleFormAction( "doitnow" ) );
 echo "<a href=\"javascript:$call;\">klick</a><br />";

 
 assert("!\$form->isNew()");

}
else if ( $form->isFinished() )
{
}

























































?>
