<?php










































global $XNL_PATH;
define("INCLUDE_PATH", $XNL_PATH.'/gentics/gentics_sql_query/DB');

include_once($XNL_PATH.'/gentics/gentics_lib.inc.php');
include_once($XNL_PATH.'/gentics/gentics_sql_query/PEAR.php');
include_once($XNL_PATH.'/gentics/gentics_sql_query/DB.php');


function xnl_func_gentics_sql_query($code, &$info) {
 $dsn = $info->getParam('dsn');
 $dbtype = $info->getParam('dbtype');
 $server = $info->getParam('server');
 $protocol = $info->getParam('protocol');
 $port = $info->getParam('port');
 $user = $info->getParam('user');
 $pass = $info->getParam('pass');
 $dbname = $info->getParam('dbname');
 $query = $info->getParam('query');
 $limit = $info->getParam('limit');
 $template = $info->getParam('template');

 if (!$dbtype) $dbtype = 'mysql';
 if (!$server) $server = 'localhost';

 
 
 if (!$dsn) {
 $dsn = "$dbtype://";
 if ($user) {
 $dsn .= $user;
 if ($pass) $dsn .= ':'.$pass;
 $dsn .= '@';
 }
 if ($protocol) $dsn .= $protocol.'+';
 $dsn .= $server;
 if ($port) $dsn .= ':'.$port;
 if ($dbname) $dsn .= '/'.$dbname;
 }

 $db = DB::connect($dsn, FALSE); 
 if (DB::isError($db)) {
 $info->error( "connect", $db->getMessage() );
 return "";
 }
 dbSetCharset($db, $info->getParam("charset"), $info, false);

 $res = $db->query($query);

 if (DB::isError($res)) {
 $info->error( "query", $res->getMessage() );
 return "";
 }
 
 $count = 0;
 while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {

 if (DB::isError($row)) {
 $info->error( "fetchRow", $row->getMessage() ); 
 continue;
 }

 $count++;
 $row_value = $template;
 foreach ($row as $k => $v) {
 $row_value = str_replace("<$k>", $v, $row_value);
 }
 $ret .= $row_value;
 }

 $res->free();

 $db->disconnect();
 return $ret;
}

?>
