<?php
 if ( $argc < 3 )
 {
 echo "USAGE: changelog_php.php <update_root> <configfile> <phpfile>\n\n";
 die;
 }
 $CONFIG_FILE = $argv[2];
 $UPDATE_ROOT = $argv[1];
 $INCLUDE_FILE = $argv[3];
 $APPLY_ONLY_DB_CHANGES = false;

 
 function halt( $id, $text )
 {
 echo "HALT called: id($id), text: $text\n\n";
 exit( 1 );
 }
 
 require_once( $CONFIG_FILE );
 require_once( "$UPDATE_ROOT/lib/misc/calctime.func.php" );
 require_once( "$UPDATE_ROOT/lib/db/cache.func.php" );
 require_once( "$UPDATE_ROOT/lib/str/version.func.php");
 require_once( "$UPDATE_ROOT/lib/db/db.func.php" );
 require_once( "$UPDATE_ROOT/lib/db/query.func.php" );
 if ($SETTINGS["dbtype"] == "ora") $tmp = "oracle";
 else if ($SETTINGS["dbtype"] == "mysql") $tmp = "mysql";
 else die("invalid dbtype...");
 require_once( "$UPDATE_ROOT/lib/db/$tmp.func.php" );

 
 $DBNAME = $SETTINGS["db"];
 $DB = mydb_connect($SETTINGS["db"], $SETTINGS["server"], $SETTINGS["login"], $SETTINGS["pw"]);

 require( $INCLUDE_FILE );
 return 0;
?>
