<?php





$HTTP_HEADER = true;

function http_header($contentType='text/html', $charset="ISO-8859-1") {

 global $HTTP_HEADER, $JS, $FEATURE;

 if ($HTTP_HEADER) {
 if ( !$FEATURE["norevalidate"] ) $revalidate = ", must-revalidate";
 header("Content-type: $contentType; charset=$charset");
 header("Expires: Mon, 5 Jun 1978 01:23:45 GMT");
 header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
 header("Cache-Control: no-cache $revalidate");
 header("Pragma: no-cache");
 return true;
 }
}

















function compression_level() {
 global $GZCOMPRESS, $GZCOMPRESS_LEVEL, $GZCOMPRESS_OVERRIDE, $FEATURE;
 if (!isset($GZCOMPRESS_LEVEL)) {
 $GZCOMPRESS_LEVEL = $FEATURE["use_default_gzcompress"] ? 9 : 0;
 }
 if (!$GZCOMPRESS_OVERRIDE && $GZCOMPRESS && $GZCOMPRESS_LEVEL > 0) {
 return $GZCOMPRESS_LEVEL;
 }
 else {
 return false;
 }
}








function cancel_output_buffer() {
 global $GZCOMPRESS_OVERRIDE;
 $override = $GZCOMPRESS_OVERRIDE;
 $GZCOMPRESS_OVERRIDE = true;
 ob_end_clean();
 $GZCOMPRESS_OVERRIDE = $override;
}
















function set_output_buffer_for_type($type) {
 
 cancel_output_buffer();

 
 
 if (0 === strpos($type, "text/") && false !== compression_level()) {

 
 
 
 
 if ( ! preg_match('/\bMSIE [1-6]\b/', $_SERVER['HTTP_USER_AGENT']) ) {
 ob_start("ob_gzhandler", 1);
 }
 }
}

function myflushhandler($buffer) {
 
 $out = $buffer;
 if ( class_exists("GUIFactory") ) {
 if ( GUIFactory::isInitialized() ) {
 $main = GUIFactory::getMainGUI();
 
 
 $out = $main->prepareOutput( $buffer );
 }
 }
 $level = compression_level();
 if (false == $level) {
 return $out;
 }
 else {
 
 
 
 
 return ob_gzhandler($out, $level);
 }
}











function core_file_header($type, $content_length = null, $cache = true) {

 
 
 set_output_buffer_for_type($type);

 header("Content-type: $type");

 
 
 
 
 if ( ! is_null($content_length) && false === compression_level() ) {
 header("Content-Length: $content_length");
 }

 if ($cache) {
 
 
 
 

 
 
 
 
 $max_age = 60*60*8;
 header("Expires: ". gmdate("D, d M Y H:i:s", time() + $max_age) . " GMT");
 header("Cache-Control: public, max-age=$max_age");
 }
}




function file_header($type="application/octet-stream", $filename = "unknown", $mod = "", $filesize = "", $attachment = false) {

 
 $max_age = 5184000;
 $exp_gmt = gmdate("D, d M Y H:i:s", time() + $max_age) . " GMT";

 
 
 
 
 header("Expires: " . $exp_gmt);

 
 
 header("Cache-Control: private, max-age=$max_age");

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 
 if ($filesize && false === compression_level()) {
 header("Content-Length: " . $filesize);
 }

 header("Content-Type: $type");
 if ($attachment){
 header("Content-Disposition: attachment; filename=$filename");
 } else {
 header("Content-Disposition: filename=$filename");
 }
}

function img_header($type) {
 header("Content-Type: $type");
 header("Expires: ". gmdate("D, d M Y H:i:s", time() + 5184000) . " GMT");
}

?>
