<?php

if ( ! perm_can_view_template($TEMPLATE_ID, null)) {
 halt(3, "no perms to view template (props) $TEMPLATE_ID in folder $FOLDER_ID");
}


$IS_PREVIEWING = true;

GUIFactory::setMainGUI("main");
$main = &GUIFactory::getGUI("main");
$main->setCSSEnabled( FALSE );
if ($FEATURE["no_pageedit_js"]) {
 $main->setMinimalJSEnabled( TRUE );
}

if ($id) $TEMPLATE_ID = $id;
if (!$TEMPLATE_ID) halt(7,"no template_id for viewing template: TEMPLATE_ID($TEMPLATE_ID)");
mysession_var_reg("TEMPLATE_ID");
mysession_var_unreg("OBJTAG_ID");
mysession_var_unreg("PAGE_ID");

load_menu(12007, $T_TEMPLATE, $TEMPLATE_ID, i18n('354.preview'));

if ( $NODERELATED_TEMPLATE_EDIT )
{
 $NODERELATED[$DO][] = $NODERELATED_TEMPLATE_EDIT;
 node_include( "browser" );
 $NODERELATED[$DO][] = $TEMPLATE_SOURCE_EXT;
}
if ($USER_ID == is_locked_by($TEMPLATE_ID,"template")) {
 node_include( "browser" );
 $NODERELATED[$DO][] = $TEMPLATE_SAVE;
 if ($FEATURE["template_release"]) {
 $NODERELATED[$DO][] = $TEMPLATE_RELEASE;
 }
}
$NODERELATED[$DO][] = $related_tpl;
$NODERELATED[$DO][] = $TEMPLATE_PAGENEW;

if ($FEATURE['javaparser']) {

 node_class("cntemplateobject");
 $baseObj = new CNTemplateObject($TEMPLATE_ID);
 node_class("codeparser");
 $parser = new CodeParser($baseObj, false, true, CN_EM_PREVIEW, false);
 $source = $parser->render();

 if ($FEATURE["history"]) {
 $res = query("SELECT name FROM template WHERE id = ".sqlf_tl_num($TEMPLATE_ID));
 if ($res["num"] == 1) {
 $JS .="
top.main.ass.GTXHistory.add({
	id: " . $TEMPLATE_ID . ",
	type: \"template\",
	name: \"" . addslashes( $res["arr"][0]["name"]) . "\",
	href: \"&do=12003&id=$TEMPLATE_ID&TEMPLATE_ID=$TEMPLATE_ID&FOLDER_ID=$FOLDER_ID&NODE_ID=$NODE_ID\",
	icon: \"?do=11&module=content&img=template.gif\"
});";
 }
 }


} else {
 
 if ($FEATURE["xnl"]) {

 node_class("cntemplateobject");
 $baseObj = new CNTemplateObject($TEMPLATE_ID);
 
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlParser->setShowErrors(true);
 $xnlParser->setEvaluate(true);
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(false);
 $xnlParser->clearEventMap();
 }
 $tpl = get_template_source($TEMPLATE_ID);
 $ml = $tpl["ml"];
 $source = $tpl["source"];
 
 $tags = obj_translate($TEMPLATE_ID,"template");
 if (!$FEATURE["reset_visited_tags"]) { $TEMPLATETAG_VISITED = Array(); $CONTENTTAG_VISITED = Array(); }
 $tmp["id"] = $FOLDER_ID;
 $tmp["type"] = $T_FOLDER;
 $foldertags = obj_translate($tmp,"obj");
 if ($FEATURE['template_objprop']) {
 $tmp["id"] = $TEMPLATE_ID;
 $tmp["type"] = $T_TEMPLATE;
 $templatetags = obj_translate($tmp,"obj",$TEMPLATE_ID,"template");
 }
 
 
 
 if (!$tags) $tags = array();
 if (!$foldertags) $foldertags = array();
 if (!$templatetags) $templatetags = array();
 $tags = $templatetags + $foldertags + $tags;

 $source = code_translate($source,$tags,"template", false, Array(), $T_TEMPLATE, $TEMPLATE_ID);

 
 if ($FEATURE["xnl"]) {
 $source = $xnlParser->parse($source);
 }
}
?>
