<?php

class CNContentGroupObject extends CNObject {
 
 var $cgid;
 
 function CNContentGroupObject($id = 0) {
 parent::CNObject();
 $this->setID($id);
 }

 function _setID($id) {
 $this->cgid = $id;
 }

 function getID() {
 return $this->cgid;
 }

 function setName($name) {
 $this->setFieldValue("name", $name);
 }

 function setCode($code) {
 $this->setFieldValue("code", $code);
 }

 function getName() {
 return $this->getFieldValue("name");
 }

 function getCode() {
 return $this->getFieldValue("code");
 }
 
 function getFallbackLanguage($nodeId) {
 $sql = "SELECT * FROM contentgroup, node_contentgroup WHERE node_contentgroup.contentgroup_id = contentgroup.id AND 
		        node_contentgroup.node_id = ".sqlf_tl_num($nodeId)." ORDER BY node_contentgroup.sortorder ASC";
 $rs = query($sql, true, 1);
 
 }
 
 function getPropertyNames() {
 return array("id"=>i18n("ID"), "name"=>i18n("name"), "code"=>i18n("Code"));
 }
 
 function &getProperty($key) {
 switch ($key) {
 case "id":
 $class = new IntObject($this->cgid);
 break;
 case "name":
 $class = new StringObject($this->getName());
 break;
 case "code":
 $class = new StringObject($this->getCode());
 break;
 default:
 $class =& parent::getProperty($key);
 break;
 }
 return $class;
 }
}

?>
