<?php













function objtranslatecache_clear($id = 0,$type = 0) {
 global $T_PAGE, $T_PAGECONTENT, $T_TEMPLATE, $FEATURE;
 if ( !$FEATURE["objtranslatecache"] )
 return;

 if (!$id && !$type) {
 $sql = "DELETE FROM objtranslatecache";
 query($sql);
 }

 else if ($id && $type == $T_PAGE) {
 $page = get_pageinfo($id);
 $sql = "DELETE FROM objtranslatecache WHERE o_id = ".sqlf_tl_num($page["content_id"])." AND o_type = ".sqlf_tl_num($T_PAGECONTENT);
 query($sql); 
 $sql = "DELETE FROM objtranslatecache WHERE o_id = ".sqlf_tl_num($id)." AND o_type = ".sqlf_tl_num($T_PAGE);
 query($sql);
 }

 else if ($id && $type == $T_PAGECONTENT) {
 $sql = "SELECT id FROM page WHERE content_id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "DELETE FROM objtranslatecache WHERE o_id = ".sqlf_tl_num($key["id"])." AND o_type = ".sqlf_tl_num($T_PAGE);
 query($sql);
 }
 }

 else if ($id && $type == $T_TEMPLATE) {
 $sql = "DELETE FROM objtranslatecache WHERE o_id = ".sqlf_tl_num($id)." AND o_type = ".sqlf_tl_num($T_TEMPLATE);
 query($sql);
 } else halt(7,"objtranslatecache_clear: invalid id($id) or type($type)");
}


function dirt_linked_of_all() {
 
 global $DEBUG, $FEATURE;
 
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "dirt_linked_of_all()<br>";
 
 if ($FEATURE["objtranslatecache"]) {
 objtranslatecache_clear();
 }

 $sql = "UPDATE page SET status = 1 WHERE status = 2";
 query($sql);
 
}

function dirt_linked_of_construct($cid,$depth = 0) {

 global $DEBUG, $FEATURE;

 if ( $FEATURE['nodirt'] ) {
 decho('DO NOT DIRT: dirt_linked_of_construct()<br>', 'nodirt');;
 return;
 }


 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "dirt_linked_of_construct($cid)<br>";

 $sql = "SELECT content_id FROM contenttag WHERE construct_id = ".sqlf_tl_num($cid);
 $rs = query($sql);

 $where = "content_id IN (";
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $where .= sqlf_tl_num($val["content_id"]).",";
 }
 }
 $where .= "-1)";

 
 $sql = "SELECT id FROM page WHERE $where";
 $rs = query($sql);

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 dirt_linked_of_page($val["id"],false,$depth);
 }
 }

 
 $sql = "SELECT template_id FROM templatetag WHERE construct_id = ".sqlf_tl_num($cid);
 $rs = query($sql);

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 dirt_linked_of_template($val["template_id"], $depth);
 }
 }

 
 
}

function dirt_linked_of_type($type_id,$obj_id) {

 global $DEBUG, $FEATURE;

 if ( $FEATURE['nodirt'] ) {
 decho('DO NOT DIRT: dirt_linked_of_type()<br>', 'nodirt');;
 return;
 }

 $content_ids = get_linked_of_type($type_id,$obj_id);
 if (is_array($content_ids)) {
 while (list($key,$val) = each($content_ids)) {
 $content_id = substr($key,1);
 $where .= sqlf_tl_num($content_id).",";
 }
 $sql = "SELECT id FROM page WHERE content_id IN ($where-1)";
 $rs = query($sql);
 while(list($key,$val) = each($rs["arr"])) {
 dirt_linked_of_page($val["id"]);
 }
 }
}

function get_linked_of_type($type_id,$page_id = 0,$depth = 0, $info = false) {

 
 if ($depth >= 1) return array();

 global $DEBUG, $T_PAGE, $T_FOLDER;

 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "- get_linked_of_type($type_id,$page_id) -->><br>";

 $sqlpart = ($info) ? "value.info = ".sqlf_tl_num($page_id) : "value.value_ref = ".sqlf_tl_num($page_id);

 $sql = "SELECT value.contenttag_id FROM value, part 
WHERE value.part_id = part.id AND part.type_id = ".sqlf_tl_num($type_id)." AND value.contenttag_id > 0 AND $sqlpart";
 $rsw = query($sql);
 if ($rsw["num"] > 0) {
 $where = "id IN (";
 while (list($key,$row) = each($rsw["arr"])) {
 $where .= sqlf_tl_num($row["contenttag_id"]).",";
 }
 $where .= "-1)";
 
 $sql = "SELECT content_id FROM contenttag WHERE $where";
 $rs = query($sql,true);
 
 if ($rs["arr"]) 
 while (list($key,$val) = each($rs["arr"])) {
 
 
 $ret["c".$val["content_id"]] = true;
 }

 }

 
 
 $sql = "SELECT value.templatetag_id FROM value, part
WHERE value.part_id = part.id AND part.type_id = ".sqlf_tl_num($type_id)." AND value.templatetag_id > 0 AND $sqlpart";
 $rst = query($sql);
 if ($rst["num"] > 0) {
 while (list($key,$val) = each($rst["arr"])) {
 $sql = "SELECT template_id FROM templatetag WHERE id = ".sqlf_tl_num($val["templatetag_id"]);
 $rs = query($sql);
 dirt_linked_of_template($rs["arr"][0]["template_id"],$depth + 1);
 }
 }

 
 $sql = "SELECT value.objtag_id FROM value, part
WHERE value.part_id = part.id AND part.type_id = ".sqlf_tl_num($type_id)." AND value.objtag_id  > 0 AND $sqlpart";
 $rs = query($sql,true);
 if ($rs["num"] > 0) 
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "SELECT objtag.obj_id, objtag.obj_type FROM objtag WHERE id = ".sqlf_tl_num($val["objtag_id"]);
 $r = query($sql,true);
 $r = $r["arr"][0];
 if ($r["obj_type"] == $T_PAGE) {
 dirt_linked_of_page($r["obj_id"],false,$depth + 1);
 }
 if ($r["obj_type"] == $T_FOLDER) {
 dirt_linked_of_folder($r["obj_id"],false,$depth + 1);
 }
 }
 
 

 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "- get_linked_of_type($type_id,$page_id) <<--<br>";

 return $ret;
}
 

$DIRT_LINKED_FOLDERS = array();

$DIRT_LINKED_PAGES = array();

function dirt_linked_of_page($page_id, $dsonly = false, $depth = 0) {
 
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "dirt_linked_of_page($page_id, $dsonly, $depth)<br>"; 

 global $T_PAGE, $FEATURE, $DIRT_LINKED_FOLDERS,$DIRT_LINKED_PAGES, $NAMECHANGE, $FEATURE, $T_PAGECONTENT;

 if ( $FEATURE['nodirt'] ) {
 decho('DO NOT DIRT: dirt_linked_of_page()<br>', 'nodirt');;
 return;
 }

 if ($DIRT_LINKED_PAGES[$page_id]) { if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "cached.<br>"; return false; }
 elseif (!$dsonly) $DIRT_LINKED_PAGES[$page_id] = true;

 $page = get_pageinfo($page_id);
 $folder_id = $page["folder_id"];

 
 if (!$FEATURE["diffpub"]) return;
 
 $where = "content_id IN (";

 
 if (!$dsonly) {
 

 if ($FEATURE["objtranslatecache"]) {
 objtranslatecache_clear($page_id,$T_PAGE);
 }
 
 $sql = "UPDATE page SET status = 1 WHERE content_id = ".sqlf_tl_num($page["content_id"])." AND status = 2";
 if ($page["content_id"]) query($sql);
 
 
 if ($depth > 1 || ($depth == 1 && !$NAMECHANGE)) return false;
 
 
 $content_ids1 = get_linked_of_type(4,$page_id,$depth);
 
 $content_ids2 = get_linked_of_type(11,$page_id,$depth,true);

 
 $content_ids = array_merge($content_ids1,$content_ids2);
 

 if (is_array($content_ids)) {
 while (list($key,$val) = each($content_ids)) {
 $content_id = substr($key,1);
 
 if ($FEATURE["diffpub"] && $content_id) {
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt content_id($content_id)<br>\n";
 $where .= sqlf_tl_num($content_id).",";
 }
 }
 }
 
 
 $sql = "SELECT contenttag.content_id FROM contenttag, ds, ds_obj WHERE
contenttag.id = ds.contenttag_id AND contenttag.id = ds_obj.contenttag_id AND
ds_obj.o_id = ".sqlf_tl_num($page_id)." AND ds.o_type = ".sqlf_tl_num($T_PAGE)." AND ds.is_folder = 2";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 if ($row["content_id"]) $where .= sqlf_tl_num($row["content_id"]).",";
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt content_id(".$row["content_id"].") (ds)<br>\n";
 }
 }
 $sql = "SELECT templatetag.template_id FROM templatetag, ds, ds_obj WHERE
templatetag.id = ds.templatetag_id AND templatetag.id = ds_obj.templatetag_id AND
ds_obj.o_id = ".sqlf_tl_num($page_id)." AND ds.o_type = ".sqlf_tl_num($T_PAGE)." AND ds.is_folder = 2";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt template_id(".$row["template_id"].") (ds):<br>\n";
 dirt_linked_of_template($row["template_id"],$depth + 1);
 }
 }
 
 }

 
 if ($folder_id && $DIRT_LINKED_FOLDERS["$folder_id"] != 2) {
 
 $sql = "SELECT contenttag.content_id FROM contenttag, ds, ds_obj WHERE
contenttag.id = ds.contenttag_id AND contenttag.id = ds_obj.contenttag_id AND
ds_obj.o_id = ".sqlf_tl_num($folder_id)." AND ds.o_type = ".sqlf_tl_num($T_PAGE)." AND ds.is_folder = 1";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt content_id(".$row["content_id"].") (ds, folder:$folder_id)<br>\n";
 if ($row["content_id"]) $where .= sqlf_tl_num($row["content_id"]).",";
 }
 }
 
 $sql = "SELECT templatetag.template_id FROM templatetag, ds, ds_obj WHERE
templatetag.id = ds.templatetag_id AND templatetag.id = ds_obj.templatetag_id AND 
ds_obj.o_id = ".sqlf_tl_num($folder_id)." AND ds.o_type = ".sqlf_tl_num($T_PAGE)." AND ds.is_folder = 1";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt template_id(".$row["template_id"].") (ds, folder:$folder_id)<br>\n";
 dirt_linked_of_template($row["template_id"],$depth + 1);
 }
 }
 
 
 
 
 $DIRT_LINKED_FOLDERS["$folder_id"] = 2;

 
 $folder = get_folderinfo($folder_id);
 $mother = $folder["mother"];
 
 while ($mother != 0 && !$DIRT_LINKED_FOLDERS["$mother"]) {

 
 $sql = "SELECT contenttag.content_id FROM contenttag, ds, ds_obj WHERE
contenttag.id = ds.contenttag_id AND contenttag.id = ds_obj.contenttag_id AND
ds_obj.o_id = ".sqlf_tl_num($mother)." AND recursion = 1 AND ds.o_type = ".sqlf_tl_num($T_PAGE)." AND ds.is_folder = 1";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt content_id(".$row["content_id"].") (ds rec, folder:$mother)<br>\n";
 if ($row["content_id"]) $where .= sqlf_tl_num($row["content_id"]).",";
 }
 }

 $sql = "SELECT templatetag.template_id FROM templatetag, ds, ds_obj WHERE
templatetag.id = ds.templatetag_id AND templatetag.id = ds_obj.templatetag_id AND
ds_obj.o_id = ".sqlf_tl_num($mother)." AND recursion = 1 AND ds.o_type = ".sqlf_tl_num($T_PAGE)." AND ds.is_folder = 1";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo " + dirt template_id(".$row["template_id"].") (ds rec, folder:$mother)<br>\n";
 dirt_linked_of_template($row["template_id"],$depth + 1);
 }
 }
 
 
 $DIRT_LINKED_FOLDERS["$mother"] = 1;

 $folder = get_folderinfo($mother);
 $mother = $folder["mother"];
 }

 }

 $where .= "-1)";
 if ($where != "content_id IN (-1)") {
 $sql = "SELECT id FROM page WHERE $where AND status = 2";
 $rs = query($sql);
 if ($rs["arr"]) {
 while (list($key,$row) = each($rs["arr"])) {
 dirt_linked_of_page($row["id"],false,$depth + 1);
 }
 }
 }




























}

function dirt_linked_of_template($template_id,$depth = 0) {

 global $FEATURE, $DEBUG, $T_TEMPLATE;

 if ( $FEATURE['nodirt'] ) {
 decho('DO NOT DIRT: dirt_linked_of_template()<br>', 'nodirt');;
 return;
 }


 if (!$FEATURE["diffpub"] || $depth > 1) return false;

 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "dirt_linked_of_template($template_id, $depth)<br>";

 if ($FEATURE["objtranslatecache"]) objtranslatecache_clear($template_id,$T_TEMPLATE);

 
 $content_ids = get_linked_of_type(20,$template_id,$depth,true);

 if (is_array($content_ids)) {
 $where = "content_id IN (";
 while (list($key,$val) = each($content_ids)) {
 $content_id = substr($key,1);





 $where .= sqlf_tl_num($content_id).",";
 }
 $where .= "-1) OR";
 }

 
 $sql = "SELECT id FROM page WHERE ($where template_id = ".sqlf_tl_num($template_id).")";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$val) = each($rs["arr"])) {
 dirt_linked_of_page($val["id"], false, $depth);
 }
 }
}

function dirt_linked_of_folder($folder_id, $dsonly = false, $depth = 0) {

 global $DEBUG, $FEATURE;

 if ( $FEATURE['nodirt'] ) {
 decho('DO NOT DIRT: dirt_linked_of_folder()<br>', 'nodirt');;
 return;
 }


 if ($DEBUG["echo"] && $DEBUG["diffpub"]) echo "dirt_linked_of_folder($folder_id, $dsonly, $depth)<br>";

 $sql = "SELECT id FROM page WHERE folder_id = ".sqlf_tl_num($folder_id)." AND (status = 2 OR status = 1)";
 if ($FEATURE["diffpub"]) $rs = query($sql);
 if ($rs["num"] > 0)
 while (list($key,$row) = each($rs["arr"])) {
 dirt_linked_of_page($row["id"],$dsonly, $depth);
 }
}

?>
