<?php




















class ErrorTagTranslator extends TagTranslator
{
 var $d_errors = array();

 function ErrorTagTranslator()
 {
 
 }

 function translate( $tag, $content, $closer, $subject, $start, $end )
 {
 global $TAG_PREFIX;
 $plen = strlen("<$TAG_PREFIX ");
 $errorsFound = false;
 
 $error = array();
 $error["start"] = $start;
 $error["end"] = $end;
 $error["misplaced_tags"] = array();

 $pos = strpos( $tag, "<$TAG_PREFIX " );
 
 $errorsFound = $pos;
 decho("tag:$tag<hr>\ncontent:$content<hr>\ncloser:$closer<hr>\nsubject:$subject<hr>\nstart:$start<hr>\nend:$end<hr>\n", 'findtagerror');
 while ( $pos )
 {
 $mptag = array();
 $mptag["start"] = $pos;
 $mptag["end"] = get_tag_end( $tag, $pos+1 );
 
 if ( $mptag["end"] < 0 ) break;
 $mptag["name"] = trim(substr( $tag, $pos + $plen, $mptag["end"] - ($pos+$plen) ));
 $error["misplaced_tags"][] = $mptag;
 
 $pos = strpos( $tag, "<$TAG_PREFIX ", $mptag["end"]+1 );
 }
 if ( $errorsFound )
 {
 $this->d_errors[] = $error;
 }
 }
}

function find_tag_errors( $tags )
{
 $invalid_tags = array();
 foreach ( $tags as $tagname=>$tag )
 {
 if ( is_array($tag["err"]) )
 {
 $error = array();
 foreach ( $tag["err"] as $key => $err )
 {
 if ( $err["inpageeditable"] || $tag["inpageeditable"] )
 {
 $partid = $err["partid"];
 foreach ( $err["err"] as $ekey => $parterr )
 {
 for ( $j=0; $j<count($parterr["misplaced_tags"]); $j++ )
 {
 $parterr["misplaced_tags"][$j]["tagid"] = $tags[$parterr["misplaced_tags"][$j]["name"]]["id"];
 }
 $parterr["partid"] = $partid;
 $error[] = $parterr;
 }
 }
 }
 
 if ( count( $error ) > 0 )
 {
 $itag = array();
 $itag["name"] = $tagname;
 $itag["content"] = $tag["value"];
 $itag["tagid"] = $tag["id"];
 $itag["error"] = $error;
 if ( !$tag["auto"] )
 $invalid_tags[$itag["tagid"]] = $itag; 
 }
 }
 }
 return $invalid_tags;
}

function find_tag_error( $tag )
{

 global $ERROR_TAGS, $ERROR_TAGS_CLOSERS;

 $ERR_TRANS = new ErrorTagTranslator();
 parse_tags( $tag, $ERROR_TAGS, $ERROR_TAGS_CLOSERS, $ERR_TRANS );
 return $ERR_TRANS->d_errors;
}


?>
