<?php

node_include ("contentgroup");

function get_overviewqueue( $id = 0, $check_perm = true ) {

 global $USER_ID, $T_PAGE, $T_TEMPLATE, $DIC, $PAGE_STATI;

 $sql = "SELECT"
 . " ds_obj.id       , ds_obj.contenttag_id, ds_obj.templatetag_id,"
 . " ds_obj.objtag_id, ds_obj.o_id,"
 . " ds.o_type,"
 . " page.id pid      , page.name pname      , page.editor peditor,"
 . " page.edate pedate,	page.filename        , page.description,"
 . " page.status      , page.priority        , page.contentgroup_id contentgroup,"
 . " page.cdate pcdate, page.creator pcreator, page.folder_id,"
 . " template.id tid        , template.name tname,"
 . " template.editor teditor, template.edate tedate,"
 . " objtag.obj_id oid, objtag.obj_type otype"
 . " FROM ds JOIN ds_obj ON ds.id = ds_obj.ds_id"
 . " LEFT JOIN contenttag ON contenttag.id = ds_obj.contenttag_id"
 . " LEFT JOIN page ON page.content_id = contenttag.content_id"
 . " LEFT JOIN templatetag ON templatetag.id = ds_obj.templatetag_id"
 . " LEFT JOIN template ON template.id = templatetag.template_id"
 . " LEFT JOIN objtag ON objtag.id = ds_obj.objtag_id"
 
 
 . " LEFT JOIN page page_target"
 . "        ON page_target.id = o_id AND o_type = " . sql_num(T_PAGE)
 . " LEFT JOIN template templ_target"
 . "        ON templ_target.id = o_id AND o_type = " . sql_num(T_TEMPLATE)
 . " LEFT JOIN folder folder_target"
 . "        ON folder_target.id = o_id AND o_type = " . sql_num(T_FOLDER)
 . " LEFT JOIN contentfile file_target"
 . "        ON file_target.id = o_id"
 . "       AND o_type IN (" . sql_num(CT_FILE) . "," . sql_num(T_IMAGE) . ")"
 . " LEFT JOIN objtag objtag_target"
 . "        ON objtag_target.id = o_id"
 . "       AND o_type NOT IN ("
 . sql_num(T_PAGE)
 . "," . sql_num(T_TEMPLATE)
 . "," . sql_num(T_FOLDER)
 . "," . sql_num(CT_FILE)
 . "," . sql_num(T_IMAGE)
 . ")"
 . " WHERE";
 if ($id) {
 $sql .= " ds_obj.id = ".sqlf_tl_num($id);
 } else {
 $sql .= " auser = 0";
 }
 $sql .= " AND ("
 
 . "      page_target.id is not null"
 . " OR  templ_target.id is not null"
 . " OR folder_target.id is not null"
 . " OR   file_target.id is not null"
 . " OR objtag_target.id is not null"
 . ")";

 $rs = query($sql);

if (is_array($rs["arr"]))
while (list($key,$val) = each($rs["arr"])) {

 if (!$check_perm || perm($USER_ID,$val['o_type'],$val["o_id"],26)) {
 
 $target = resolve_base_object($val['o_type'], $val['o_id']); 
 
 if (!$target['id']) {
 

 continue;
 }
 $obj = null;
 
 if ( $val['contenttag_id'] ){
 $obj = resolve_base_object($T_PAGE, $val['pid']);
 
 if ($content_id_done[$obj['content_id']][$target['type']][$target['id']]) {
 
 continue;
 } else {
 $content_id_done[$obj['content_id']][$target['type']][$target['id']] = true;
 }
 } else if ( $val['templatetag_id'] ) {
 $obj = resolve_base_object($T_TEMPLATE, $val['tid']);
 } else if ( $val['objtag_id'] ){
 $obj = resolve_base_object($val['otype'], $val['oid']);
 $obj['name'] .= ' ('.i18n('objectproperty').')';
 }
 
 if (!$obj['id']) {
 

 continue;
 }

 $o_queue[$key] = $val;
 $o_queue[$key]['type'] = $obj['type'];
 $o_queue[$key]['o_type'] = $obj['type_id'];
 $o_queue[$key]['o_id'] = $obj['id'];
 
 if (!$o_queue[$key]['pid']) $o_queue[$key]['pid'] = $obj['id'];
 $o_queue[$key]['target_id'] = $target['id'];
 $o_queue[$key]['target_name'] = $target['name'];
 $o_queue[$key]['target_icon'] = img($target['icon']);
 $o_queue[$key]['target_type'] = $target['type'];
 $o_queue[$key]['target_type_id'] = $target['type_id'];
 
 $o_queue[$key]['edate'] = db2date($obj["edate"]); 
 $o_queue[$key]['name'] = $obj['name'];
 $user = array();
 if ( $obj['editor'] ) {
 $user = get_userinfo($obj["editor"]);
 }
 $o_queue[$key]["editor"] = $user["lastname"]." ".$user["firstname"];
 $o_queue[$key]["editor_id"] = $obj['editor'];
 $o_queue[$key]["icon"] = img($obj['icon']);

 if($o_queue[$key]["pcreator"]) {
 $user = get_userinfo ($o_queue[$key]["pcreator"]);
 }
 $o_queue[$key]["pcreator"] = $user["lastname"] . " " . $user["firstname"];
 $o_queue[$key]["pcdate"] = db2date ($o_queue[$key]["pcdate"]); 

 if($o_queue[$key]["peditor"]) {
 $user = get_userinfo ($o_queue[$key]["peditor"]);
 }
 $o_queue[$key]["peditor"] = $user["lastname"] . " " . $user["firstname"];
 $o_queue[$key]["pedate"] = db2date ($o_queue[$key]["pedate"]);

 $status = $o_queue[$key]["status"];
 if ($status == 1)
 $status = 2;

 $o_queue[$key]["status"] = i18n($PAGE_STATI[$status]);

 if ($FEATURE["contentgroup3"])
 {
 $cgs = get_contentgroups ();

 if ($o_queue[$key]["contentgroup"])
 {
 $tmp = $o_queue[$key]["contentgroup"];
 $o_queue[$key]["languageass"] = "<br>" . i18n ("language") . ": " . $cgs[$tmp]["code"];
 }
 else
 $o_queue[$key]["languageass"] = "";
 }

 $folder_info = get_folderinfo ($o_queue[$key]["folder_id"]);
 
 $sql = "SELECT name FROM folder where node_id = '" . sqlf_escaped($folder_info["node_id"]) . "' AND mother = 0";
 $rs2 = query ($sql);
 $o_queue[$key]["node"] = $rs2["arr"][0]["name"];

 $o_queue[$key]["fname"] = $folder_info["name"];
 }
}
return $o_queue;
}

function resolve_base_object($type, $id) {
 global $T_PAGE, $T_TEMPLATE, $T_FOLDER, $T_IMAGE, $T_FILE;
 if (!$id) return array('name'=>'Error in resolving name...');
 $ret = array();
 if ( $type == $T_PAGE ) {
 $ret = get_pageinfo($id);
 $ret['type'] = i18n('page');
 } else if ( $type == $T_TEMPLATE ) {
 $ret = get_templateinfo($id);
 $ret['type'] = i18n('template');
 } else if ( $type == $T_FOLDER ) {
 $ret = get_folderinfo($id);
 $ret['type'] = i18n('folder');
 } else if ( $type == $T_IMAGE || $type == $T_FILE) {
 $ret = get_fileinfo($id);
 $ret['type'] = ($type == $T_IMAGE)?i18n('image'):i18n('file');
 } else {
 $sql = "SELECT * FROM objtag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $ret = resolve_base_object($rs['arr'][0]['obj_type'], $rs['arr'][0]['obj_id'] );
 }
 $ret['type_id'] = $type;
 return $ret;
}

?>
