<?php

function get_cn_view_menu( $perm )
{
 global $DIC, $FEATURE, $STAG, $T_PAGE, $T_TEMPLATE, $T_IMAGE, $T_GALLERY, $T_FILE, $T_FOLDER, 
 $ICO_PAGE, $ICO_TPL, $ICO_IMG, $ICO_GALLERY, $ICO_FILE, $ICO_FOLDER, $T_MAPS, $ICO_MAP, $FOLDER_ID, $USER_ID, $ICO_WORKFLOW;
 $menu_view_name = i18n('menu_view');

 $mnu_view = array("", $menu_view_name, "$STAG", "list", "mnunode", "l");
 $mnu_view_pages = array($menu_view_name, i18n('379.pages'), "$STAG&do=13011&t_type=$T_PAGE", "list", "", 0, $ICO_PAGE);
 $mnu_view_templates = array($menu_view_name, i18n('Templates'), "$STAG&do=13013&t_type=$T_TEMPLATE", "list", "", 0, $ICO_TPL);
 $mnu_view_images = array($menu_view_name, i18n('images'), "$STAG&do=15001&type=img&t_type=$T_IMAGE", "list", "", 0, $ICO_IMG);
 $mnu_view_gallery = array($menu_view_name, i18n('cn_gallery'), "$STAG&do=15001&type=gl&t_type=$T_GALLERY", "list", "", 0, $ICO_GALLERY);
 $mnu_view_files = array($menu_view_name, i18n('Files'), "$STAG&do=15001&type=file&t_type=$T_FILE", "list", "", 0, $ICO_FILE);
 $mnu_view_subfolders = array($menu_view_name, i18n('Folders'), "$STAG&do=13012&t_type=$T_FOLDER", "list", "", 0, $ICO_FOLDER);
 $mnu_view_workflows = array($menu_view_name, i18n('sn_workflows'), "$STAG&do=706&type=$T_FOLDER", "list", "", 0, $ICO_WORKFLOW);
 $mnu_view_maps = array($menu_view_name, i18n( "VMaps" ), "$STAG&do=999&o_type=$T_FOLDER&o_id=$FOLDER_ID&o_prop=maps&o_menu=11001", "list", "", 0, $ICO_MAP);
 $MENU[] = $mnu_view;

 if ($perm[11] || perm_hasfolderviewpermissions( $USER_ID, $FOLDER_ID, $T_PAGE )) $MENU[] = $mnu_view_pages;
 if ($perm[15]) $MENU[] = $mnu_view_templates;
 if ($perm[11] || perm_hasfolderviewpermissions( $USER_ID, $FOLDER_ID, $T_FILE )) $MENU[] = $mnu_view_images;
 if ($perm[11] && $FEATURE["gallery"]) $MENU[] = $mnu_view_gallery;
 if ($perm[11] || perm_hasfolderviewpermissions( $USER_ID, $FOLDER_ID, $T_FILE )) $MENU[] = $mnu_view_files;
 $MENU[] = $mnu_view_subfolders;
 if ( $FEATURE["workflow"] && $perm[22]) $MENU[] = $mnu_view_workflows;
 if ( $FEATURE["map"] && $perm[23]) $MENU[] = $mnu_view_maps;
 
 return $MENU;
}

function get_cn_search_menu( $perm ) 
{

global $DIC, $STAG, $T_PAGE, $T_TEMPLATE, $T_IMAGE, $T_FILE, $T_FOLDER, $ICO_PAGE, $ICO_TPL, $ICO_IMG, $ICO_FILE, $ICO_FOLDER ;

$menu_cn_search_name = i18n('menu_search');
$menu_cn_search = array("", $menu_cn_search_name, "$STAG", "list", "mnunode", "l");
$menu_cn_search_pages = array($menu_cn_search_name, i18n('379.pages'), "$STAG&do=13011&t_type=$T_PAGE&advanced=1&search=", "list","", 0, $ICO_PAGE);
$menu_cn_search_templates = array($menu_cn_search_name, i18n('Templates'), "$STAG&do=13013&t_type=$T_TEMPLATE&advanced=1&search=", "list","", 0, $ICO_TPL);
$menu_cn_search_images = array($menu_cn_search_name, i18n('images'), "$STAG&do=15001&type=img&t_type=$T_IMAGE&advanced=1&search=", "list","", 0, $ICO_IMG);
$menu_cn_search_files = array($menu_cn_search_name, i18n('Files'), "$STAG&do=15001&type=file&t_type=$T_FILE&advanced=1&search=", "list","", 0, $ICO_FILE);
$menu_cn_search_subfolders = array($menu_cn_search_name, i18n('Folders'), "$STAG&do=13012&t_type=$T_FOLDER&advanced=1&search=", "list", "", 0, $ICO_FOLDER);


$MENU_CN_SEARCH = Array();
$MENU_CN_SEARCH[] = $menu_cn_search;
$content = false;
if ( $perm[11] )
{
 $MENU_CN_SEARCH[] = $menu_cn_search_pages;
 $MENU_CN_SEARCH[] = $menu_cn_search_images;
 $MENU_CN_SEARCH[] = $menu_cn_search_files;
 $content = true;
}
if ( $perm[15] )
{
 $MENU_CN_SEARCH[] = $menu_cn_search_templates;
 $content = true;
}
$MENU_CN_SEARCH[] = $menu_cn_search_subfolders;
if ( $content )
 return $MENU_CN_SEARCH;
return Array();

}

function get_cn_new_menu( $perm ) 
{
 global $FILE_FETCH_PER_NODE_PERMISSION, $NODE_ID, $FILE_FETCH_PER_NODE_URL, $DIC, $FILE_FETCH_URL, $FILE_FETCH_EVAL, $T_FOLDER, $STAG, $ICO_PAGE, $ICO_TPL, $ICO_IMG, $ICO_FILE,
 $ICO_FOLDER, $FEATURE, $ICO_IMPORT, $FOLDER_ID, $T_FILE, $USER_ID, $CONTENTGROUP_ID, $T_PAGE, $ICO_WORKFLOW;

 $menu_new_name = i18n('54.new');
 $mnu_new = array("", $menu_new_name, "$STAG", "list", "mnunode", "l");
 $mnu_new_page = array($menu_new_name, i18n('page'), "$STAG&do=14000&cmd=new&PAGE_ID=", "list", "", 0, $ICO_PAGE);
 $mnu_new_pagevar = array($menu_new_name, i18n('page_variation'), "$STAG&do=14008&cmd=new", "list", "", 0, $ICO_PAGE);
 $mnu_new_template = array($menu_new_name, i18n('Template'), "$STAG&do=12000&cmd=new", "list", "", 0 , $ICO_TPL);
 $mnu_new_image = array($menu_new_name, i18n('image'), "$STAG&do=15000&type=img&cmd=new", "list", "", 0, $ICO_IMG);

 
 if (isset($FILE_FETCH_PER_NODE_URL[$NODE_ID])) {
 $file_fetch_url = $FILE_FETCH_PER_NODE_URL[$NODE_ID];
 } else {
 $file_fetch_url = $FILE_FETCH_URL;
 }

 if ($FILE_FETCH_EVAL) {
 eval("\$file_fetch_url = \"$file_fetch_url\";");
 }
 $mnu_new_image_import = array($menu_new_name, i18n("cn_image_import"), $file_fetch_url, "_new", "", 0, $ICO_IMG);

 
 $mnu_new_file_image = array($menu_new_name, i18n('File') . ' / ' . i18n('Image'), "$STAG&do=15009&type=file&cmd=new", "list","", 0, $ICO_FILE); 

 $mnu_new_node = array($menu_new_name, i18n('folder'), "$STAG&do=11000&cmd=new", "list", "", 0, $ICO_FOLDER);
 $mnu_html_import = array($menu_new_name, i18n("cn_html_import"), "$STAG&do=11004", "list", "", 0, $ICO_IMPORT);
 $mnu_new_workflow = array($menu_new_name, i18n('sn_workflow'), "$STAG&do=701&type=$T_FOLDER", "list", "", 0, $ICO_WORKFLOW);


 $allow_filecreate = $perm[12] || perm( $USER_ID, $T_FOLDER, $FOLDER_ID, 12, NULL, $T_FILE, 11 );
 $allow_pagecreate = $perm[12] || perm( $USER_ID, $T_FOLDER, $FOLDER_ID, 12, $CONTENTGROUP_ID, $T_PAGE, 11 );
 if ($allow_filecreate || $allow_pagecreate || $perm[16] || $perm[8] || ($FEATURE["workflow"] && $perm[22])) {
 $MENU[] = $mnu_new;
 if ($allow_pagecreate) { 
 $MENU[] = $mnu_new_page;
 if ($FEATURE["pagevar"]) $MENU[] = $mnu_new_pagevar;
 
 if ($perm[23]) {
 if ($FEATURE["html_import"]) $MENU[] = $mnu_html_import;
 }
 }
 if ($perm[16]) $MENU[] = $mnu_new_template;
 
 
 $hideFileFetchMenuEntry = false;
 
 if (isset($FILE_FETCH_PER_NODE_PERMISSION)) {

 
 
 $hideFileFetchMenuEntry = true;
 
 
 $groups = user_getmothergroups($USER_ID);
 
 foreach ($groups as $group_id => $value) {
 
 
 
 
 
 
 if (isset($FILE_FETCH_PER_NODE_PERMISSION[$group_id])) {
 $allowed_nodes = $FILE_FETCH_PER_NODE_PERMISSION[$group_id];
 if( in_array($NODE_ID, $allowed_nodes) ) {
 $hideFileFetchMenuEntry = false;
 }
 }
 }
 
 }

 
 if (!isset($FILE_FETCH_URL) && !isset($FILE_FETCH_PER_NODE_URL[$NODE_ID])) {
 $hideFileFetchMenuEntry = true;
 }

 if (!$hideFileFetchMenuEntry && $allow_filecreate && $FEATURE["file_fetch"]) { 
 $MENU[] = $mnu_new_image_import;
 }
 
 if ($allow_filecreate) $MENU[] = $mnu_new_file_image;
 if ($perm[8]) $MENU[] = $mnu_new_node;
 if ($FEATURE["workflow"] && $perm[22]) $MENU[] = $mnu_new_workflow;
 }
 return $MENU;
}

?>
