<?php


function publishpage_msg($page_id,$folder_id="",$user_id="") {

 global $USER_ID, $T_FOLDER, $TIME, $PUBLISHMSG, $T_PAGE;

 
 if (!$PUBLISHMSG) return;

 if (!$user_id) $user_id = $USER_ID;
 
 
 $sql = "SELECT name, folder_id, contentgroup_id, time_pub FROM page WHERE id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 $pagename = $rs["arr"][0]["name"];
 $page_contentgroup_id = $rs['arr'][0]['contentgroup_id'];
 $time_pub = $rs["arr"][0]["time_pub"];
 $sql = "SELECT firstname, lastname FROM systemuser WHERE id = ".sqlf_tl_num($user_id);
 $rs = query($sql);
 $username = $rs["arr"][0]["firstname"]." ".$rs["arr"][0]["lastname"];
 if ($time_pub > 0) {
 $msg = i18n( "{0} wants to publish the page <pageid {1}> at {2}.", 0, $username, $page_id, db2date($time_pub, i18n("LOCALIZED_DATETIMEFORMAT")) );
 $subject = i18n( "{0} wants to publish the page \"{1}\" at {2}", 0, $username, $pagename, db2date($time_pub, i18n("LOCALIZED_DATETIMEFORMAT")) );
 } else {
 $msg = i18n( "{0} wants to publish the page <pageid {1}>.", 0, $username, $page_id );
 $subject = i18n( "{0} wants to publish the page \"{1}\"", 0, $username, $pagename );
 }

 if (!$folder_id) $folder_id = $rs["arr"][0]["folder_id"];
 
 $groups = user_findroots($USER_ID, 0);

 
 $msggroups = array();
 $checkedgroups = array();

 
 foreach ($groups as $group) {
 
 if (!perm_group($group, $T_FOLDER, $folder_id, 13, $page_contentgroup_id, $T_PAGE, 12)) {
 continue;
 }

 $foundmother = false;
 $mother = $group;
 while (!$foundmother) {
 
 $mother = group_getmother($mother);
 
 if ($mother == 0 || in_array($mother, $checkedgroups)) {
 
 $foundmother = true;
 break;
 }
 
 $checkedgroups[] = $mother;
 if (perm_group($mother, $T_FOLDER, $folder_id, 19, $page_contentgroup_id, $T_PAGE, 14)) {
 $msggroups[] = $mother;
 $foundmother = true;
 break;
 }
 }
 }

 
 if (count($msggroups) > 0) {
 $sql = "SELECT DISTINCT user_id FROM user_group WHERE usergroup_id in (".implode(",", sqlf_tl_num_array($msggroups)).")";
 $rs = query($sql);

 if ($rs["num"] > 0) {
 
 $user_done = array();
 while (list($k, $v) = each($rs["arr"])) {
 if (!$user_done[$v["user_id"]]) {
 $iid = msg($msg, $v["user_id"], $user_id);
 $user_done[$v["user_id"]] = true;
 $pubuserids[] = $v["user_id"];
 }
 }
 }
 } else {
 
 }

 if ($iid) {
 triggerEvent( T_PUBQUEUE, $page_id, EVENT_NOTIFY, new EventObject(array("userids" => $pubuserids, "username" => $username, 'subject' => $subject, "message_id" => $iid)) );
 }
}

?>
