<?php

global $T_TYPE, $USER_ID, $DIC;

if ($USER_ID == 1) {
 $T_TYPE_STANDARD_SQL = "SELECT DISTINCT id, itemorder, name, type_id, LOWER(name) AS l_name  FROM tree 
WHERE mother = \$nid ORDER BY itemorder, l_name";
} else {
 $T_TYPE_STANDARD_SQL = "SELECT DISTINCT id, itemorder, name, type_id, LOWER(name) AS l_name  FROM tree, perm WHERE perm.o_id = tree.id 
AND perm.o_type = tree.type_id AND (\$PERMSQL) AND mother = \$nid AND perm.perm LIKE '1%' 
ORDER BY itemorder, l_name";
}

global $T_ROOT, $ICO_ROOT;

$T_TYPE[$T_ROOT] = array(
 "name" =>i18n('root'),
 "object" =>false,
 "self" =>"SELECT name FROM tree WHERE id=",
 "fkt" =>"tree_i18n(0)",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"node_id",
 "linktarget" =>"list",
 "allowlink" =>false,
 "link" =>"do=3",
 "append" =>"",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_ROOT),
 "folderclosed" =>evalf_string_dq($ICO_ROOT)
);

global $T_ADMIN, $ICO_ADMIN;
$T_TYPE[$T_ADMIN] = array(
 "name" =>i18n('menu_administration'),
 "object" =>false,
 "self" =>"SELECT name FROM tree WHERE id=",
 "self_i18n" =>i18n('administration'),
 
 "fkt" =>"tree_i18n(\$nid)",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"node_id",
 "linktarget" =>"list",
 "allowlink" =>false,
 "link" =>"",
 "append" =>"</b>",
 "prepend" =>"<b>",
 "folderopen" =>evalf_string_dq($ICO_ADMIN),
 "folderclosed" =>evalf_string_dq($ICO_ADMIN)
);

global $T_REGEX, $ICO_REGEX;
$T_TYPE[$T_REGEX] = array(
 "name" =>i18n('menu_regex'),
 "object" =>false,
 
 "self_i18n" =>i18n('Regex.Admin'),
 "link" =>"do=802",
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_REGEX),
 "folderclosed" =>evalf_string_dq($ICO_REGEX)
);

global $T_USERADMIN, $ICO_ADMINUSER;
$T_TYPE[$T_USERADMIN] = array(
 "name" =>i18n('menu_users'),
 "object" =>false,
 
 "self_i18n" =>i18n('user'),
 "linkvar" =>"treemenu",
 "linktarget" =>"list",
 "allowlink" =>true,

 "link" =>"do=401",
 "folderopen" =>evalf_string_dq($ICO_ADMINUSER),
 "folderclosed" =>evalf_string_dq($ICO_ADMINUSER)
 );

global $T_USER, $ICO_USER;
$T_TYPE[$T_USER] = array(
 "name" =>i18n('user'),
 "object" =>true,
 "self" =>"SELECT login AS name FROM systemuser WHERE id=",
 "linkvar" =>"USER_ID",
 "linktarget" =>"main",
 "allowlink" =>false,
 "link" =>"",
 "folderopen" =>evalf_string_dq($ICO_USER),
 "folderclosed" =>evalf_string_dq($ICO_USER)
 );

global $T_SETTING, $ICO_USER;
$T_TYPE[$T_SETTING] = array(
 "name" =>i18n('settings'),
 "object" =>false,
 
 "self_i18n" =>i18n('settings'),
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=410",
 "folderopen" =>evalf_string_dq($ICO_USER),
 "folderclosed" =>evalf_string_dq($ICO_USER)
 );

global $T_GROUPADMIN, $T_GROUP, $SQLAS, $ICO_ADMINGROUP;
$T_TYPE[$T_GROUPADMIN] = array(
 "name" =>i18n('sn_groups'),
 "object" =>false,
 
 "self_i18n" =>i18n('sn_groups'),
 "sql" =>"SELECT usergroup.*, ".sqlf_tl_num_eval_dq($T_GROUP)." AS type_id, LOWER(usergroup.name) AS l_name FROM usergroup WHERE \".node_func(\"user_getrootsql\",true,".evalf_num($USER_ID).").\" ORDER BY l_name",
 "sqlleaf" =>"SELECT usergroup.id, ".sqlf_tl_num_eval_dq($T_GROUP)." AS t_type FROM usergroup LEFT JOIN usergroup $SQLAS child ON (usergroup.id = child.mother) WHERE child.id is null",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=501&GROUP_ID=0",
 "folderopen" =>evalf_string_dq($ICO_ADMINGROUP),
 "folderclosed" =>evalf_string_dq($ICO_ADMINGROUP)
 );

global $T_GROUP, $ICO_GROUP;
$T_TYPE[$T_GROUP] = array(
 "name" =>i18n('412.group'),
 "object" =>true,
 "self" =>"SELECT name FROM usergroup WHERE id=",
 "sql" =>"SELECT usergroup.*, ".sqlf_tl_num_eval_dq($T_GROUP)." as type_id, LOWER(name) AS l_name FROM usergroup WHERE mother = \$nid ORDER BY l_name",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"GROUP_ID",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=503",
 "folderopen" =>evalf_string_dq($ICO_GROUP),
 "folderclosed" =>evalf_string_dq($ICO_GROUP),
 "context" =>"node_func(\"get_group_context_menu\",true, \$nid, \$ntype )"
 );

global $T_DEMO, $ICO_TREEMENU;
$T_TYPE[$T_DEMO] = array(
 "name" =>"Demo",
 "object" =>false,
 
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "allowlink" =>true,
 "link" =>"do=1000",
 "linktarget" =>"list",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
 
global $T_TASKADMIN, $T_TASK, $T_TASK_TEMPLATE, $T_JOB, $ICO_TASK, $ICO_TREEMENU;
$T_TYPE[T_TASKADMIN] = array(
 "name" =>i18n('scheduler'),
 "object" =>false,
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 
 "allowlink" =>true,
 "link" =>"do=899",
 "linktarget" =>"list",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );

global $T_TASKADMIN, $T_TASK, $T_TASK_TEMPLATE, $T_JOB, $ICO_TASK, $ICO_TREEMENU;

$T_TYPE[T_TASK] = array(
 "name" =>i18n('sn_task'),
 "object" =>true,
 "self" =>"SELECT name FROM task WHERE id=",
 "allowlink" =>true,
 "ntype" =>"type_id",
 "nid" =>"id",
 "link" =>"do=861&id=\$id",
 "linktarget" =>"list",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
$T_TYPE[T_TASK_GROUP] = array(
 "name" =>i18n('sn_task'),
 "object" =>true,
 "self" =>"SELECT name FROM task WHERE id=",
 "allowlink" =>false,
 "fkt" =>"node_func(\\\"get_tasks\\\",true);",
 "link" =>"do=899",
 "linktarget" =>"list",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
$T_TYPE[T_TASK_TEMPLATE] = array(
 "name" =>i18n('sn_task_template'),
 "object" =>true,
 "self" =>"SELECT name FROM tasktemplate WHERE id=",
 "allowlink" =>true,
 "ntype" =>"type_id",
 "nid" =>"id",
 "link" =>"do=851&id=\$id",
 "linktarget" =>"list",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
$T_TYPE[T_TASK_TEMPLATE_GROUP] = array(
 "name" =>i18n('sn_task'),
 "object" =>true,
 "self" =>"SELECT name FROM tasktemplate WHERE id=",
 "allowlink" =>false,
 "fkt" =>"node_func(\\\"get_tasktemplates\\\",true);",
 "link" =>"do=899",
 "linktarget" =>"list",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
$T_TYPE[T_JOB] = array(
 "name" =>i18n('sn_task_date'),
 "object" =>true,
 "self" =>"SELECT name FROM job WHERE id=",
 "allowlink" =>true,
 "ntype" =>"type_id",
 "nid" =>"id",
 "link" =>"do=871&id=\$id",
 "linktarget" =>"list",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
$T_TYPE[T_JOB_GROUP] = array(
 "name" =>i18n('sn_task'),
 "object" =>true,
 "self" =>"SELECT name FROM job WHERE id=",
 "allowlink" =>false,
 "fkt" =>"node_func(\\\"get_jobs\\\",true);",
 "link" =>"do=899",
 "linktarget" =>"list",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );
 
global $T_FEATUREADMIN, $T_FEATUREGROUP, $ICO_ADMINFEATURE, $ICO_FEATUREGROUP;
$T_TYPE[$T_FEATUREADMIN] = array(
 "name" =>i18n("Feature.Admin"),
 "object" =>false,
 "self_i18n" =>i18n("Feature.Admin"),
 "fkt" =>"tree_featuregroup(0)",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"fgroup",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=70",
 "folderopen" =>evalf_string_dq($ICO_ADMINFEATURE),
 "folderclosed" =>evalf_string_dq($ICO_ADMINFEATURE)
 );

$T_TYPE[$T_FEATUREGROUP] = array(
 "name" =>i18n("Feature Group"),
 "self" =>"SELECT name_i18n FROM featuregroup WHERE id=",
 "fkt" =>"tree_featuregroup(\$nid)",
 "ntype" =>"type_id",
 "nid" =>"nid",
 "nname" =>"name",
 "linkvar" =>"fgroup",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=70",
 "folderopen" =>evalf_string_dq($ICO_FEATUREGROUP),
 "folderclosed" =>evalf_string_dq($ICO_FEATUREGROUP)
);
 
global $T_DEVTOOLS, $ICO_DEVTOOLS;
$T_TYPE[$T_DEVTOOLS] = array(
 "name" =>i18n('menu_dev_tools'),
 "object" =>false,
 
 "self_i18n" =>i18n('devtools'),
 
 "fkt" =>"tree_i18n(\$nid)",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"t",
 "linktarget" =>"main",
 "allowlink" =>false,
 "folderopen" =>evalf_string_dq($ICO_DEVTOOLS),
 "folderclosed" =>evalf_string_dq($ICO_DEVTOOLS)
 );

global $ICO_SELFUPDATE;
$T_TYPE[T_SELFUPDATE] = array(
 "name" => "AutoUpdate",
 "object" => false,
 "self_i18n" => "AutoUpdate",
 "fkt" => "tree_i18n(\$nid)",
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 "linktarget" => "list",
 "linkvar" => "t", 
 "allowlink" => true,
 "link" => "do=1040",
 "folderopen" => evalf_string_dq($ICO_SELFUPDATE),
 "folderclosed" => evalf_string_dq($ICO_SELFUPDATE)
 );

global $T_LOGACTION, $ICO_LOGACTION;
$T_TYPE[$T_LOGACTION] = array(
 "name" =>i18n('menu_log'),
 "object" =>false,
 
 "self_i18n" =>i18n('logs'),
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=805",
 "folderopen" =>evalf_string_dq($ICO_LOGACTION),
 "folderclosed" =>evalf_string_dq($ICO_LOGACTION)
 );

global $T_TREEMENU, $ICO_TREEMENU;
$T_TYPE[$T_TREEMENU] = array(
 "name" =>i18n('menu_tree'),
 "object" =>false,
 
 "self_i18n" =>i18n('menu_tree'),
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=811",
 "folderopen" =>evalf_string_dq($ICO_TREEMENU),
 "folderclosed" =>evalf_string_dq($ICO_TREEMENU)
 );

global $T_BUG, $ICO_BUG;
$T_TYPE[$T_BUG] = array(
 "name" =>i18n('menu_bug'),
 "object" =>false,
 
 "self_i18n" =>i18n('menu_bug'),
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=807",
 "folderopen" =>evalf_string_dq($ICO_BUG),
 "folderclosed" =>evalf_string_dq($ICO_BUG)
 );

global $T_INBOX, $ICO_INBOX;
$T_TYPE[$T_INBOX] = array(
 "name" =>i18n('915.inbox'),
 "object" =>false,
 
 "self_i18n" =>i18n('915.inbox'),
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=8",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_INBOX),
 "folderclosed" =>evalf_string_dq($ICO_INBOX)
);

global $T_TRASH, $ICO_TRASH;
$T_TYPE[$T_TRASH] = array(
 "name" =>i18n('trash_module'),
 "object" =>false,
 
 "self_i18n" =>i18n('trash_module'),
 "linkvar" =>"t",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=820",
 "folderopen" =>evalf_string_dq($ICO_TRASH),
 "folderclosed" =>evalf_string_dq($ICO_TRASH)
);

global $T_ERROR, $ICO_BUG;
$T_TYPE[$T_ERROR] = array(
 "name" =>i18n('sn_error'),
 "self_i18n" =>i18n('sn_error'),
 "object" =>false,
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_BUG),
 "folderclosed" =>evalf_string_dq($ICO_BUG),
 "link" =>"do=821"
);

global $T_OBJPROPADMIN, $ICO_OBJPROPADMIN;
$T_TYPE[$T_OBJPROPADMIN] = array(
 "name" =>i18n('menu_userproperties'),
 "fkt" =>"node_func(\\\"get_objprops\\\",true)",
 "object" =>false,
 
 "self_i18n" =>i18n('Object Properties'),
 "nid" =>"id",
 "nname" =>"name",
 "ntype" =>"type",
 "linktarget" =>"list",
 "allowlink" =>true,
 "link" =>"do=451",
 "folderopen" =>evalf_string_dq($ICO_OBJPROPADMIN),
 "folderclosed" =>evalf_string_dq($ICO_OBJPROPADMIN)
 );


global $T_OBJPROP, $ICO_OBJPROP;
$T_TYPE[$T_OBJPROP] = array(
 "name" =>i18n('Object Properties'),
 "object" =>true,
 "fkt" =>"node_func(\\\"get_objpropelements\\\",true,\$nid)",
 "nid" =>"id",
 "nname" =>"name",
 "ntype" =>"type",
 
 "folderopen" =>evalf_string_dq($ICO_OBJPROPADMIN),
 "folderclosed"=>evalf_string_dq($ICO_OBJPROPADMIN),
 "link" =>"do=450",
 "linktarget" =>"list",
 "linkvar" =>"id",
 "allowlink" =>true
);

global $T_OBJPROP_CATEGORY, $ICO_OBJPROPADMIN;
$T_TYPE[T_OBJPROP_CATEGORY] = array(
 "name" => i18n( "Object Property Categories" ),
 "self_i18n" => i18n( "Object Property Categories" ),
 "object" => false,
 "folderopen" => evalf_string_dq($ICO_OBJPROPADMIN),
 "folderclosed"=> evalf_string_dq($ICO_OBJPROPADMIN),
 "link" => "do=454",
 "linktarget" => "list",
 "allowlink" => true
 );

$T_TYPE[T_OBJPROP_MAINTENANCE] = array(
 "name" => i18n( "Object Property Maintenance" ),
 "self_i18n" => i18n( "Object Property Maintenance" ),
 "object" => false,
 "folderopen" => evalf_string_dq($ICO_OBJPROPADMIN),
 "folderclosed"=> evalf_string_dq($ICO_OBJPROPADMIN),
 "link" => "do=456",
 "linktarget" => "list",
 "allowlink" => true
);

global $FEATURE;
if ($FEATURE['objtag_perm']) {
global $T_OBJPROPELEMENT, $ICO_OBJPROPELEMENT;
$T_TYPE[$T_OBJPROPELEMENT] = array(
 "name" =>i18n('Objectproperty Definition'),
 "object" =>true,
 "self_i18n" =>'?no_name?',
 "linktarget" =>"list",
 "allowlink" =>true,
 "linkvar" =>"id",
 "link" =>"do=453",
 
 
 "folderopen" =>evalf_string_dq($ICO_OBJPROPADMIN),
 "folderclosed" =>evalf_string_dq($ICO_OBJPROPADMIN)
 );
}

global $T_CONSISTENCY, $ICO_FOLDER;
$T_TYPE[$T_CONSISTENCY] = array(
 "name" =>i18n('sn_consistency'),
 "object" =>false,
 
 "self_i18n" =>i18n('sn_consistency'),
 "folderopen" =>evalf_string_dq($ICO_FOLDER),
 "folderclosed" =>evalf_string_dq($ICO_FOLDER),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=823"
);

global $T_CRYPTPW, $ICO_FOLDER;
$T_TYPE[$T_CRYPTPW] = array(
 "name" =>i18n('sn_crypt_passwords'),
 "object" =>false,
 
 "self_i18n" =>i18n('sn_crypt_passwords'),
 "folderopen" =>evalf_string_dq($ICO_FOLDER),
 "folderclosed" =>evalf_string_dq($ICO_FOLDER),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=824"
);

global $T_UPDATEINDEX, $ICO_TRASH;
$T_TYPE[$T_UPDATEINDEX] = array(
 "name" =>i18n('sn_update_index'),
 "object" =>false,
 
 "self_i18n" =>i18n('sn_update_index'),
 "folderopen" =>evalf_string_dq($ICO_TRASH),
 "folderclosed" =>evalf_string_dq($ICO_TRASH),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=825"
);

global $T_DEVSCRIPTS, $ICO_TRASH;
$T_TYPE[$T_DEVSCRIPTS] = array(
 "name" =>i18n('sn_dev.scripts'),
 "object" =>false,
 
 "self_i18n" =>i18n('sn_dev.scripts'),
 "folderopen" =>evalf_string_dq($ICO_TRASH),
 "folderclosed" =>evalf_string_dq($ICO_TRASH),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=826"
);

global $T_PTREE;
$T_TYPE[$T_PTREE] = array(
 "name" =>i18n('tn_folder_create_err'),
 "object" =>false,
 
 "self_i18n" =>i18n('tn_folder_create_err'),
 "linkvar" =>"ID"
);

global $T_DBADMIN, $ICO_TRASH;
$T_TYPE[$T_DBADMIN] = array(
 "name" =>i18n('sn_db_admin'),
 "object" =>false,
 
 "self_i18n" =>i18n('sn_db_admin'),
 "folderopen" =>evalf_string_dq($ICO_TRASH),
 "folderclosed" =>evalf_string_dq($ICO_TRASH),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=831"
);

global $T_WORKFLOWADMIN, $ICO_WORKFLOWADMIN;
$T_TYPE[$T_WORKFLOWADMIN] = array(
 "name" =>i18n('sn_workflow.admin'),
 "object" =>true,
 
 "self_i18n" =>i18n('sn_workflow.admin'),
 "fkt" =>"node_func(\\\"get_workflow_objects\\\",true)",
 "ntype" =>"type",
 "nid" =>"id",
 "nname" =>"name",
 "folderopen" =>evalf_string_dq($ICO_WORKFLOWADMIN),
 "folderclosed"=>evalf_string_dq($ICO_WORKFLOWADMIN),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=702",
);

global $T_WORKFLOWOBJECT;
$T_TYPE[$T_WORKFLOWOBJECT] = array(
 "name" =>i18n('sn_workflow_object'),
 "object" =>false,
 "folderopen" =>"\$icon",
 "folderclosed"=>"\$icon",
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=701&dotype=admin&type=\$id"
);

global $T_WORKFLOW, $ICO_WORKFLOW;
$T_TYPE[$T_WORKFLOW] = array(
 "name" =>i18n('sn_workflow'),
 "object" =>false,
 "self" =>"SELECT name FROM workflow WHERE id = ",
 "folderopen" =>evalf_string_dq($ICO_WORKFLOW),
 "folderclosed"=>evalf_string_dq($ICO_WORKFLOW),
 "allowlink" =>false,
 "fkt" =>"node_func(\\\"get_workflowroot\\\",true, \$nid)",
 "ntype" =>"type",
 "nid" =>"id",
 "nname" =>"name"
);

global $T_WORKFLOWEVENT, $ICO_WORKFLOWEVENT;
$T_TYPE[$T_WORKFLOWEVENT] = array(
 "name" =>i18n('sn_event'),
 "object" =>false,
 "self" =>"SELECT keyword FROM triggerevent WHERE id = ",
 "folderopen" =>evalf_string_dq($ICO_WORKFLOWEVENT),
 "folderclosed"=>evalf_string_dq($ICO_WORKFLOWEVENT),
 "allowlink" =>false,
 "fkt" =>"get_sub_reactions(\$id)",
 "ntype" =>"type",
 "nid" =>"id",
 "nname" =>"name"
);

global $T_WORKFLOWREACTION, $ICO_WORKFLOWREACTION;
$T_TYPE[$T_WORKFLOWREACTION] = array(
 "name" =>i18n('sn_reaction'),
 "object" =>false,
 "self" =>"SELECT keyword FROM reaction WHERE id = ",
 "folderopen" =>evalf_string_dq($ICO_WORKFLOWREACTION),
 "folderclosed"=>evalf_string_dq($ICO_WORKFLOWREACTION),
 "allowlink" =>false,
 "fkt" =>"get_sub_events(\$id)",
 "ntype" =>"type",
 "nid" =>"id",
 "nname" =>"name"
 
);

global $T_PRODUCT_INFO, $INFOPORTAL_URL;
$T_TYPE[$T_PRODUCT_INFO] = array(
 "name" =>i18n('sn_product_information'),
 "object" =>false,
 "folderopen" =>"\$icon",
 "folderclosed" =>"\$icon",
 "prepend" =>"<b>",
 "append" =>"</b>",
 "allowlink" =>true,
 "linkext" =>evalf_string_dq($INFOPORTAL_URL)."/\$id",
 "linktarget" =>"infoportal"
);

global $T_INBOX__MSG, $ICO_INBOX;
$T_TYPE[$T_INBOX_MSG] = array(
 "name" =>i18n('915.inbox'),
 "object" =>true,
 "folderopen" =>evalf_string_dq($ICO_INBOX),
 "folderclosed" =>evalf_string_dq($ICO_INBOX)
);

global $T_DICADMIN, $ICO_DICADMIN;
$T_TYPE[$T_DICADMIN] = array(
 "name" =>i18n('.node_dic'),
 "object" =>false,
 
 "self_i18n" =>i18n('.node_dic'),
 "fkt" =>"node_func(\\\"get_editable_dics\\\",true)",
 "nid" =>"id",
 "ntype" =>"type_id",
 "nname" =>"name",
 "folderopen"=>evalf_string_dq($ICO_DICADMIN),
 "folderclosed"=>evalf_string_dq($ICO_DICADMIN),
 "allowlink" =>false
);

global $T_DICTYPEADMIN, $ICO_DIC;
$T_TYPE[$T_DICTYPEADMIN] = array(
 "name" =>i18n('.node_dic'),
 "object" =>false,
 "folderopen"=>evalf_string_dq($ICO_DIC),
 "folderclosed"=>evalf_string_dq($ICO_DIC),
 "allowlink" =>true,
 "linktarget"=>"list",
 "link" =>"do=835&DIC_USERTYPE=\$nid&cmd=search"
);

global $ICO_DIC;
$T_TYPE[T_DICIMPORT] = array(
 "name" =>"Import",
 "object" =>false,
 "folderopen"=>evalf_string_dq($ICO_DIC),
 "folderclosed"=>evalf_string_dq($ICO_DIC),
 "allowlink" =>true,
 "linktarget"=>"list",
 "link" =>"do=838"
);


global $T_SOAP;
$T_TYPE[$T_SOAP] = array(
 "name" =>i18n('soap'),
 "self_i18n" =>i18n('soap'),
 "object" =>false,
 "folderopen" =>evalf_string_dq($ICO_SOAP),
 "folderclosed"=>evalf_string_dq($ICO_SOAP),
 "allowlink" =>true,
 "linktarget" =>"list",
 "link" =>"do=50"
);

if( $FEATURE['roles'] ) {
 global $ICO_ROLE;
$T_TYPE[T_ROLE] = array(
 "name" => i18n( "Roles" ),
 "self_i18n" => i18n( "Roles" ),
 "object" => false,
 "folderopen" => evalf_string_dq($ICO_ROLE),
 "folderclosed"=> evalf_string_dq($ICO_ROLE),
 "link" => "do=551",
 "linktarget" => "list",
 "allowlink" => true
 );
}

global $T_EMPTY;
$T_TYPE[$T_EMPTY] = array(
 "name" => "",
 "object" => false,
 "self_i18n" => "",
 "linkvar" => "",
 "linktarget" => "",
 "allowlink" => false,
 "link" => "",
 );

if ($FEATURE["2dotool_integration"]) {
 $T_TYPE[T_TODOTOOL] = array(
 "name" => i18n('task management'),
 "object" => false,
 "self_i18n" => i18n('task management'),
 "linktarget" => "list",
 "allowlink" =>true,
 "link" => "do=25",
 "folderopen" => evalf_string_dq($ICO_TODO),
 "folderclosed" => evalf_string_dq($ICO_TODO)
 );
}

$T_TYPE[T_MUNIN] = array(
 "name" => i18n( 'Munin output' ),
 "object" => false,
 "self_i18n" => i18n( 'Munin output' ),
 "allowlink" => true,
 "link" => "do=29",
 );


global $ICO_BUNDLE;
$T_TYPE[T_BUNDLE] = array(
 "name" => i18n('Bundle Management'),
 "object" => false,
 "linktarget" => 'list',
 'link' => 'do=1010&type=export',
 'allowlink' => true,
 "self_i18n" =>i18n('Bundle Management'),
 
 
 
 "nid" => 'id',
 "ntype" =>"type",
 "nname" =>"name",
 "folderopen" =>evalf_string_dq($ICO_BUNDLE),
 "folderclosed" =>evalf_string_dq($ICO_BUNDLE)
);

global $ICO_BUNDLE_EXPORT;
$T_TYPE[T_BUNDLE_EXPORT] = array(
 "name" => i18n('Export'),
 'object' => false,
 "linktarget" => 'list',
 'link' => 'do=1010&type=export',
 'allowlink' => true,
 "folderopen" =>evalf_string_dq($ICO_BUNDLE_EXPORT),
 "folderclosed" =>evalf_string_dq($ICO_BUNDLE_EXPORT),
 'nid' => 'id',
 'nname' => 'name',
 'ntype' => 'type_id'
 );
global $ICO_BUNDLE_IMPORT;
$T_TYPE[T_BUNDLE_IMPORT] = array(
 "name" => i18n('Import'),
 'object' => false,
 "linktarget" => 'list',
 'link' => 'do=1010&type=import',
 'allowlink' => true,
 "folderopen" =>evalf_string_dq($ICO_BUNDLE_IMPORT),
 "folderclosed" =>evalf_string_dq($ICO_BUNDLE_IMPORT),
 'nid' => 'id',
 'nname' => 'name',
 'ntype' => 'type_id'
 );

$T_TYPE[T_BUNDLE_EXPORT_ELEMENT] = array( 
 'name' => i18n( 'Export' ),
 'self' => 'select name from bundle where id = ',
 'object' => true,
 'allowlink' => true,
 'folderopen' => evalf_string_dq($ICO_BUNDLE_EXPORT),
 'folderclosed' => evalf_string_dq($ICO_BUNDLE_EXPORT),
 'nname' => 'name',
 'ntype' => 'type_id'
 );

$T_TYPE[T_BUNDLE_IMPORT_ELEMENT] = array(
 'name' => i18n( 'Import' ),
 'self' => 'select name from bundle where id = ',
 'object' => true,
 'allowlink' => true,
 'folderopen' => evalf_string_dq($ICO_BUNDLE_IMPORT),
 'folderclosed' => evalf_string_dq($ICO_BUNDLE_IMPORT),
 'nname' => 'name',
 'ntype' => 'type_id'
 );
 
global $ICO_SYSTEM_MAINTENANCE;
$T_TYPE[T_SYSTEM_MAINTENANCE] = array(
 "name" => i18n('System Maintenance'),
 "object" => false,
 "self_i18n" => i18n('System Maintenance'),
 "linktarget" => "list",
 "allowlink" => true,
 "link" => "do=1042",
 "folderopen" => evalf_string_dq($ICO_SYSTEM_MAINTENANCE),
 "folderclosed" => evalf_string_dq($ICO_SYSTEM_MAINTENANCE)
); 

if ($FEATURE["view_perms"]) {
 




 $T_TYPE[T_VIEW_GROUP] = $T_TYPE[$T_GROUP];
 $T_TYPE[T_VIEW_GROUP]["link"] = "do=510";
 $T_TYPE[T_VIEW_GROUP]["sql"] = "SELECT usergroup.*, " . T_VIEW_GROUP . " as type_id, LOWER(name) AS l_name FROM usergroup WHERE mother = \$nid ORDER BY l_name";
 $T_TYPE[T_VIEW_GROUP]["context"] = true;
 
 



 $T_TYPE[T_VIEW_PERMS] = array(
 "name" => i18n('view_perms'),
 "object" => false,
 "self_i18n" => i18n('view_perms'),
 
 "sql" => "SELECT usergroup.*, ". T_VIEW_GROUP ." AS type_id, LOWER(usergroup.name) AS l_name 
	    	FROM usergroup WHERE usergroup.id = 2 ",
 "sqlleaf" => "SELECT usergroup.id, ". T_VIEW_GROUP ." AS t_type FROM usergroup LEFT JOIN usergroup AS child ON (usergroup.id = child.mother) WHERE child.id is null",
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 "linkvar" => "t",
 "linktarget" => "list",
 "allowlink" => true,
 "link" => "do=510",
 "folderopen" => evalf_string_dq($ICO_ADMINGROUP),
 "folderclosed" => evalf_string_dq($ICO_ADMINGROUP)
 );
}

?>
